/*
 *
 */

#ifndef ___MOUSE_H__
#define ___MOUSE_H__

/* "virtual operations" on a mouse */
struct mouse_operations {
  char *name;             /* name! */
  char *desc;             /* a descriptive line */  

  BYTE proto[4];          
  int  packetlen;         /* lenght of a packet */ 
  int  howmany;           /* howmany bytes to read at a time (unused) */
  int  getextra;          /* there is a extra byte (unused) */
  int  absolute;          /* absolute pointing devide (unused) */
  int  dummy;             /* (unused) */

  int  (*open)(void*);    /* open comunication device */
  void (*close)(void);    /* close comunication device */
  void (*wait)(void);     /* wait to have a BYTE (blocking operation)*/
  int  (*get)(BYTE *ptr); /* get last BYTE */
  void (*enable)(void);   /* enable interface */ 
  void (*disable)(void);  /* disable interface */

  /* this function decode the mouse packet into a MOUSE_EVT structure */
  int  (*decode)(MOUSE_EVT *evt,unsigned char *data);
};

/* to virtualize interface beetwen a mouse device and a mouse protocol */
extern int    mousetype;
extern struct mouse_operations vmouse[];

/* functions and variables (to use virtual operation)*/
extern int  (*open_mouse)(void*);     /* open comunication device */
extern void (*close_mouse)(void);     /* close comunication device */
extern void (*wait_mouse)(void);      /* wait to have a BYTE (blocking operation)*/
extern int  (*get_mouse)(BYTE *data); /* get last BYTE */
extern void (*enable_mouse)(void);    /* enable interface */
extern void (*disable_mouse)(void);   /* disable interface */

extern char *name_mouse;
extern char *desc_mouse;
extern BYTE *proto_mouse;
extern int  packetlen_mouse;

/* used by mouse protocol task */
extern short int mouse_lim_x1;
extern short int mouse_lim_y1;
extern short int mouse_lim_x2;
extern short int mouse_lim_y2;
extern short int mouse_x;
extern short int mouse_x_mick;
extern short int mouse_y;
extern short int mouse_y_mick;
extern short int mouse_buttons;
extern short int mouse_thresholdlim;
extern MOUSE_HANDLER mouse_handler;

/* a generic mouse server */
extern TASK generalmouse_server(void);

/*
 * mouse autocursor variables
 */

/* mask to extrac the status from autocursormode */
#define STATUSMASK 0x0f

/* flags for autocursormode (there are some other flags into mouse.h) */
#define GRXCURSOR 0x100
#define TXTCURSOR 0x200

/* cursor status and flags */
extern int autocursormode;

/* this functions is used to enable/disable the cursor */
/* (it is here to be used by the mcurgrx.c  module) */
int _mouse_cursor_init(int cmd,
		       void(*my_show_cursor)(int,int),
		       void(*my_restore_cursor)(int,int)
		       );
		       
/* this is used by mcurgrx.c to know the last mouse position */
/* (to not declare saved_x & saved_y public) */
void _mouse_getsavedposition(int *xptr, int *yptr);

#endif




