#ifndef __GD_H__
#define __GD_H__

/* Std 16 colors... are in cons.h !!!*/
#include <cons.h>

/* 15bpp, 16bpp, 24bpp and 32bpp colors... */
#define color15(r, g, b) (((WORD)(r & 0xFF) << 10) | ((WORD)(g & 0xFF) << 5) | (WORD)(b & 0xFF))
#define color16(r, g, b) (((WORD)(r & 0xFF) << 11) | ((WORD)(g & 0xFF) << 5) | (WORD)(b & 0xFF))
#define color24(r, g, b) (((DWORD)(r & 0xFF) << 16) | ((DWORD)(g & 0xFF) << 8) | (DWORD)(b & 0xFF))
#define color32(r, g, b) (((DWORD)(r & 0xFF) << 16) | ((DWORD)(g & 0xFF) << 8) | (DWORD)(b & 0xFF))

/* Flags */
#define NOLINEAR 1

struct gmode {
    WORD xdim;
    WORD ydim;
    WORD bpr;
    BYTE bpp;
    WORD modenum;
};

#include "comp.h"

int gd_init(WORD flags);
void gd_showinfo(void);
int gd_setmode(WORD mode);
int gd_bsetmode(WORD mode);
WORD gd_getbpr(void);
DWORD gd_getflb(void);
DWORD gd_getmem(void);
void gd_showmodeinfo(void);
int gd_modenum(WORD x, WORD y, BYTE depth);
int gd_getmodeinfo(vga_modeinfo *m);

void Load_Write_Bank_256(BYTE bank);

void Seg_Off_256(WORD x, WORD y, WORD pitch, WORD *offs, WORD *seg);
void Seg_Off_Hi(WORD x, WORD y, WORD pitch, WORD *offs, WORD *seg);


void gd_getcolor(BYTE ind, BYTE *r, BYTE *g, BYTE *b);
void gd_setcolor(BYTE ind,BYTE r,BYTE g,BYTE b);
void gd_getpalette(BYTE start, BYTE num, BYTE *pal);
void gd_setpalette(BYTE start, BYTE num, BYTE *pal);
#endif
