#include <hartik.h>
#include <mem.h>
#include <string.h>
#include <cons.h>
#include <xdos.h>
#include "trident.h"
#include "chips.h"

int trident_chiptype;
int trident_flags;
int trident_memory;

static int trident_init(int par1, int par2)
{
    BYTE value;

    VM_out(0x3D4, 0x1f);
	/* this should detect up to 2M memory now */
    trident_memory = (VM_in(0x3D5) & 0x07) * 256 + 256;

    VM_out(0x3C4, 0x0B);
    VM_out(0x3C5, 0);

    value = VM_in(0x3C5);

    switch(value) {
	case 0x03:
	case 0x04:
	    trident_chiptype = TRIDENT_8900;
	    break;
	case 0x13:
	case 0x23:
	case 0x93:
	    trident_chiptype = TRIDENT_9000;
	    break;
	case 0x53:
	case 0x83:
	    trident_chiptype = TRIDENT_9200;
	    break;
	case 0x73:
	    trident_chiptype = TRIDENT_9420;
	    break;
	case 0xD3:
	    trident_chiptype = TRIDENT_9680;
	default:
	    trident_chiptype = TRIDENT_UNKNOWN;
/*	    trident_chiptype = TRIDENT_8800;  */
/*	    trident_chiptype = TRIDENT_9440;  */
	    break;
    }
    return 1;
}


int trident_test(void)
{
    BYTE old_value, old_misc_value, value, misc_value, power_up_value;
    int res;

    res = CHIP_NOT_FOUND;

    VM_out(0x3CE, 0x06);
    old_misc_value = VM_in(0x3CF);
    misc_value = old_misc_value & 0x03;
    misc_value |= 0x04;
    VM_out(0x3CF, misc_value);
    
    VM_out(0x3C4, 0x0E);
    old_value = VM_in(0x3C5);

    VM_out(0x3C5, 0x00);

    value = VM_in(0x3C5) & 0x0F;

    VM_out(0x3C5, old_value);

    VM_out(0x3CE, 0x06);
    VM_out(0x3CF, old_misc_value);

    if (value >= 0x02) {
	res = CHIP_FOUND;
    }else {
	VM_out(0x3C4, 0x0F);
	VM_out(0x3C5, 0x00);

	power_up_value = VM_in(0x3C5);

	if (power_up_value != 0) {
	    res = CHIP_FOUND;
	}
    }
    if (res == CHIP_FOUND) {
			trident_init(0,0);
			if (trident_chiptype != TRIDENT_UNKNOWN) {
					return 1;
			} else {
					return -1;
			}
    }
    return res;
}

void trident_showinfo()
{
    cprintf("\t Using Trident driver (%s, %dK).\n",
    	trident_chipname[trident_chiptype], trident_memory);
}

void trident_setpage(int page)
{
    WORD app;
    BYTE bb;

    bb = page;
    if ((bb & 0x02) == 0x02) {
	bb = (bb & 0xFD);
    } else {
	bb = (bb | 0x02);
    }

/*    VM_out(0x03C4, 0x0b);
    VM_out(0x03C5, VM_in(0x03C5));
    VM_in(0x3C5);	*/

/*    bb = page ^ 0x02;*/

    app = 0x0E || (bb << 8);
    
VM_out(0x3C4, 0x0E);
VM_out(0x3C5, bb);
/*    VM_outw(0x3C4, app);*/

/*
    VM_out(0x03C4, 0x0b);
    VM_out(0x03C5, VM_in(0x03C5));
    VM_in(0x3C5);	

    VM_out(0x03C4, 0x0e);
    VM_out(0x03C5, page ^ 0x02);
*/
}

DWORD trident_getmem(void)
{
    return trident_memory * 1024;
}
