#
# GNU-C 32 bit makefile
#

#
# Include KBuild Config File
#

#
# Main settings!
# 

NET_PATH     = ..
INCLUDE_PATH = ../../h
LIB_PATH     = ../../lib

CC           = gcc
C_OUTPUT     = -o $*.o
C_OPT        =  -I$(INCLUDE_PATH) -I$(INCLUDE_PATH)/sys -I$(INCLUDE_PATH)/x86 \
		-I ./include -D__BASE_CONST__ -D__C_HEADER__ -D__GNU__ \
		-O -finline-functions -fno-builtin
ASM_OPT      = -I. -I$(INCLUDE_PATH) -I$(INCLUDE_PATH)/sys -I$(INCLUDE_PATH)/x86 \
		-I./include

LIB_NAME      = comp
OBJS  = skbuff.o \
		timer.o \
		misc.o \
		auto_irq.o \
		int.o \
		net_init.o

#
# Hartik Base Network library
# Includes support for 3com card, multiprotocol support a
# basic and UDP/IP
#

.PHONY : info allclean clean depend

info : 
	@type ..\..\info.txt

all : lib$(LIB_NAME).a
	@copy lib$(LIB_NAME).a ..\..\lib

install : lib$(LIB_NAME).a
	@copy lib$(LIB_NAME).a ..\..\lib

depend deps:
	$(CC) $(C_OPT) -M $(OBJS:.o=.c) > deps

clean :
	-del *.o
	-del *.err
	-del *.a
	-del makefile

allclean : clean
	echo # Kernel Dependency file > deps
	gcd $(LIB_PATH)
	-del lib$(LIB_NAME).a
	cd ..\dev\linuxcom
	
lib$(LIB_NAME).a : $(OBJS)
	ar rs lib$(LIB_NAME).a $(OBJS)

include deps

%.o : %.c
	$(CC) $(C_OUTPUT) $(C_OPT) -c $< 
