/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        4/12/1997                                       */

/* File:        3Com.H                                          */
/* Revision:    2.0						*/

#ifndef __3COM_H__
#define __3COM_H__

#ifdef __cplusplus
extern "C" {
#endif

#define STATUS 			0x0e
   #define CMDINPROGRESS 	0x1000
   #define RXCOMPLETE 		0x0010
   #define RXERROR 		0x4000
   #define INTLATCH 		0x0001
   #define TXAVAILABLE 		0x0008
   #define RXEARLY 		0x0020
   #define INTREQ 		0x0040
   #define TXCOMPLETE 		0x0004

#define COMMAND 		0x0e
   #define SELECTWINDOW 	0x0800
   #define TXRESET 0x5800
   #define RXRESET 0x2800
   #define SETSTATUSENB 0x7800
   #define RXENABLE 0x2000
   #define TXENABLE 0x4800
   #define STARTCOAX 0x1000
   #define RXDISCARD 0x4000
   #define SETRXFILTER 0x8000
   #define ACKINTR 0x6800
   #define SETINTRENB 0x7000
   #define TXDONE 0x3800

/* Window 1 */
#define RXSTATUS 0x18
#define RXBYTES 0x1FFF
#define RXDATA 0x10
#define TXFREE	0x1C
#define TXDATA 0x10
#define TXSTATUS 0x1B

/* Window 2 */
#define STATIONADDRESSLOW 0
#define STATIONADDRESSMID 2  
#define STATIONADDRESSHIGH 4  

/* Window 3 */
#define INTERNALCONFIG 0
#define MACCONTROL 0x06

/* Window 4 */
#define MEDIASTATUS 0x0A

/* Window 5 */
#define RXFILTER 0x08

#define SETWIN(win_num) outpw(BaseAddress + COMMAND, SELECTWINDOW + win_num)

#define TXTASK 1
#define TXMEM  0
#define LOWLEV_TX_BUFFERS 50

void vortex_info(struct pci_regs *r);
void vortex_readregs(DWORD BaseAddress);
PID vortex_open(unsigned long int BaseAddress, int mode);
void vortex_close(DWORD BaseAddress);
void vortex_send_mem(DWORD BaseAddress, DWORD *txbuff, int len);
void vortex_send_msg(DWORD BaseAddress, DWORD *txbuff, int len);

#ifdef __cplusplus
};
#endif

#endif
