/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        4/12/1997                                       */

/* File:        ARP.H                                           */
/* Revision:    2.0						*/

#ifndef __ARP_H__
#define __ARP_H__

#ifdef __cplusplus
extern "C" {
#endif

#define ARP_IP_TYPE     0x0800
#define ARP_ETH_TYPE 	1
		
#define ARP_REQUEST	1
#define ARP_REPLY	2

#define ARP_MAX_ENTRIES 50
#define ARP_MAX_USED	99

#define ARP_ERROR_BASE	(ETH_ERROR_BASE + 10)
#define ARP_TABLE_FULL	(ARP_ERROR_BASE + 0)


typedef struct arp_table{
    IP_ADDR ip;
    struct eth_addr eth;
    int used;
    int time;
    int ntrans;
    void *pkt;
    BYTE valid;
} ARP_TABLE;

void arp_send(void *pkt, IP_ADDR dest, int len);
void arp_init(char *localAddr);
int arp_req(IP_ADDR dest);
void arp_sendRequest(int i);

#ifdef __cplusplus
};
#endif

#endif
