/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        4/12/1997                                       */

/* File:        Eth.H                                           */
/* Revision:    2.0						*/

#ifndef __ETH_H__
#define __ETH_H__

#ifdef __cplusplus
extern "C" {
#endif

#define LOOPBACK 2
		
#define ETH_MAX_LEN	1528
#define ETH_ARP_TYPE	0x0806
#define ETH_IP_TYPE	0x0800
#define ETH_HRT_TYPE	0x8FFF
#define ETH_MAX_PROTOCOLS	5

typedef struct eth_addr {
    BYTE ad[6];
} ETH_ADDR;

typedef struct eth_header {
    struct eth_addr dest;
    struct eth_addr source;
    WORD type;
} ETH_HEADER;

typedef struct eth_device {
    DWORD BaseAddress;
    BYTE IntLine;
    struct eth_addr addr;
} ETH_DEVICE;

#define setEthAddr(q,w) memcpy(q.ad,w.ad,sizeof(struct eth_addr))

#define ETH_ERROR_BASE		150
#define ETH_DRIVER_NOT_FOUND	(ETH_ERROR_BASE+0)
#define ETH_RXERROR	 	(ETH_ERROR_BASE+1)
#define ETH_DRIVER_RELEASE	(ETH_ERROR_BASE+2)
#define ETH_DRIVER_ADDRESS	(ETH_ERROR_BASE+3)
#define ETH_TXERROR		(ETH_ERROR_BASE+4)
#define ETH_PROTOCOL_ERROR	(ETH_ERROR_BASE+5)
#define ETH_BUFFERS_FULL	(ETH_ERROR_BASE+6)
#define ETH_NULLPROTOCOL_EXC	(ETH_ERROR_BASE+7)

unsigned short htons(unsigned short host);
unsigned short ntohs(unsigned short net);
void eth_str2Addr(char *add, struct eth_addr *ds);
void eth_printHeader(struct eth_header *p);
void eth_printPkt(char *pkt,int len);
int eth_setProtocol(WORD type, void (*recv)(void *pkt));
void *eth_setHeader(void *b, struct eth_addr dest, WORD type);
int eth_sendPkt(void *p, int len);
void *eth_getFDB(void *pkt);
int eth_init(int mode);
void eth_close(void);
void eth_getAddress(struct eth_addr *eth);

#ifdef __cplusplus
};
#endif

#endif
