#
# GNU-C 32 bit makefile
#

#
# Main settings!
# 

HARTIK       = ../..
DEV_PATH     = net
INCL     = -I$(HARTIK)/h/x86 -I$(HARTIK)/h -I$(HARTIK)/h/sys -I$(HARTIK)/drivers/linuxcom/include -I.
#INCLUDE_PATH = ../../h
LIB_PATH     = ../../lib

CC           = gcc
C_OUTPUT     = -o $*.o
C_OPT        =  $(INCL) \
		-D__BASE_CONST__ -D__C_HEADER__ -D__GNU__ \
		-O -finline-functions -fno-builtin
ASM_OPT      = -D__GNU__ -I. -I$(INCLUDE_PATH) -I$(INCLUDE_PATH)/sys -I$(INCLUDE_PATH)/x86

LIBNAME      = hnet

#
# Device driver files
#

OBJS  =  eth.o \
		ne.o \
		8390.o \
		3c509.o \
		3c59x.o \
		netbuff.o \
		arp.o \
		udpip.o \
		net.o

#OBJS  =  eth.o \
#        ne.o \
#        8390.o \
#        3c509.o \
#        3c59x.o \
#        skbuff.o \
#        timer.o \
#        misc.o \
#        auto_irq.o \
#        int.o \
#        net_init.o \
#        netbuff.o \
#        arp.o \
#        udpip.o \
#        net.o

#
# Ok! Finally the dependency rules!
#

.PHONY : info allclean clean depend

info : 
	@type ..\..\info.txt

all : lib$(LIBNAME).a
	@copy lib$(LIBNAME).a ..\..\lib

install : lib$(LIBNAME).a
	@copy lib$(LIBNAME).a ..\..\lib

depend deps:
	$(CC) $(C_OPT) -M $(OBJS:.o=.c) > deps

clean :
	-del *.o
	-del *.err
	-del *.a
	-del makefile

allclean : clean
	echo # Kernel Dependency file > deps
	gcd $(LIB_PATH)
	-del lib$(LIBNAME).a
	cd ..\drivers\$(DEV_PATH)
	
lib$(LIBNAME).a : $(OBJS)
	ar rs lib$(LIBNAME).a $(OBJS)

include deps

%.o : %.c
	$(REDIR) $(CC) $(C_OPT) $(C_OUTPUT) -c $< 
