/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        4/12/1997                                       */

/* File: 	net.C						*/
/* Revision:    1.00						*/

/*
   This module provides an interface function eth_init that initialize 
   all the network library layers (LowLev, Ethrnet, IP,...) according
   to the values passed in a net_model structure
*/

#include <hartik.h>
#include "net.h"
#include "eth.h"

/* OKKIO!!!!! net_base must change if you change NET_MAX_PROTOCOLS!!!! */
struct net_model net_base = {0, 0, {NULL, NULL, NULL, NULL, NULL, NULL, NULL,
    				  NULL, NULL, NULL, NULL, NULL, NULL, NULL,
    				  NULL, NULL, NULL, NULL, NULL, NULL}};

void net_setprotocol(struct net_model *m, void (*initfun)(void *parm), void *initparms)
{
    int i;

    i = m->numprotocol++;
    m->protocol[i].initfun=initfun;
    m->protocol[i].initparms=initparms;
}

int net_init(struct net_model *m)
{
    int i;
	int app;

    /* First, initialize the base layers: eth & lowlev */
    if (app = eth_init(m->lowlevparm) != 1) {
		return app;
	}
    /* Then, the high level layers */
    for(i = 0; i < m->numprotocol; i++) {
cprintf("Protocol %d init \n", i);
		m->protocol[i].initfun(m->protocol[i].initparms);
    }
	
	return 1;
}
