/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        25/9/1997                                       */
                           
/* File:        NetBuff.H                                       */
/* Revision:    1.00                                            */

#ifndef __NETBUFF_H__
#define __NETBUFF_H__

#ifdef __cplusplus
extern "C" {
#endif

#define NETBUFF_EXC_BASE	180
#define	NETBUFF_INIT_EXC	(NETBUFF_EXC_BASE + 0)
#define	NETBUFF_GET_EXC		(NETBUFF_EXC_BASE + 1)
#define	NETBUFF_ALREADYFREE_EXC	(NETBUFF_EXC_BASE + 2)
#define	NETBUFF_RELEASE_EXC	(NETBUFF_EXC_BASE + 3)


typedef struct netbuff{
    BYTE *b;
    BYTE **pb;
    BYTE *free;
    BYTE nbuffs;
    SEM buffersem;
} NETBUFF;

void netbuff_init(struct netbuff *netb, BYTE nbuffs, WORD buffdim);
void *netbuff_get(struct netbuff *netb, BYTE to);
void *netbuff_sequentialget(struct netbuff *netb, BYTE to);
void netbuff_release(struct netbuff *netb, void *m);

#ifdef __cplusplus
};
#endif

#endif
