/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        14/4/1997                                       */
                           
/* File:        PCI.H                                           */
/* Revision:    1.02                                            */

#ifndef __PCI_H__
#define __PCI_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef struct pci_regs {
	WORD VendorId;
	WORD DeviceId;
	WORD PciCommand;
	WORD PciStatus;
	BYTE reserved1;
	BYTE dummy;
	WORD ClassCode;
	BYTE reserved2;
	BYTE LatencyTimer;
	BYTE HeaderType;
	BYTE reserved3;
	DWORD IoBaseAddress;
	DWORD reserved4;
	DWORD reserved5;
	DWORD reserved6;
	DWORD reserved7;
	DWORD reserved8;
	DWORD reserved9;
	DWORD reserved10;
	DWORD BiosRomControl;
	DWORD reserved11;
	DWORD reserver12;
	BYTE InterruptLine;
	BYTE InterruptPin;
	BYTE MinGnt;
	BYTE MaxLat;
	DWORD InternalConfig;
} PCI_REGS;

typedef struct pci_des {
		int base;
		DWORD mem[65];
} PCI_DES;


int pci_detect(struct pci_des *p_des);
void pci_show(struct pci_des *PCIdes, int n);

#ifdef __cplusplus
};
#endif

#endif

