#
# GNU-C 32 bit makefile
#

#
# Main settings!
# 

DEV_PATH     = sound
INCLUDE_PATH = ../../h
LIB_PATH     = ../../lib

CC           = gcc
C_OUTPUT     = -o $*.o
C_OPT        =  -I$(INCLUDE_PATH) -I$(INCLUDE_PATH)/sys -I$(INCLUDE_PATH)/x86 \
		-D__BASE_CONST__ -D__C_HEADER__ -D__GNU__ \
		-O -finline-functions -fno-builtin
ASM_OPT      = -D__GNU__ -I. -I$(INCLUDE_PATH) -I$(INCLUDE_PATH)/sys -I$(INCLUDE_PATH)/x86

LIBNAME      = hsnd

#
# Device driver files
#

OBJS  = sbio.o blaster.o dma.o sound.o 

#
# Ok! Finally the dependency rules!
#

.PHONY : info allclean clean depend

info : 
	@type ..\..\info.txt

all : lib$(LIBNAME).a
	@copy lib$(LIBNAME).a ..\..\lib

install : lib$(LIBNAME).a
	@copy lib$(LIBNAME).a ..\..\lib

depend deps:
	$(CC) $(C_OPT) -M $(OBJS:.o=.c) > deps

clean :
	-del *.o
	-del *.err
	-del *.a
	-del makefile

allclean : clean
	echo # Kernel Dependency file > deps
	gcd $(LIB_PATH)
	-del lib$(LIBNAME).a
	cd ..\dev\$(DEV_PATH)
	
lib$(LIBNAME).a : $(OBJS)
	ar rs lib$(LIBNAME).a $(OBJS)

include deps

%.o : %.c
	$(REDIR) $(CC) $(C_OPT) $(C_OUTPUT) -c $< 
