/****************************************************************/
/*	TEST SUI PROCESSI PERIODICI				*/
/****************************************************************/

/* CVS $Id: ego.c,v 1.4 1999/07/16 12:27:00 massy Exp $ */

#include "hartik.h"
#include "glib.h"

#include "keyb.h"
#include "cons.h"

#define X0	10

int	t1 = 100;          /* periodo processo 1 */
int	t2 = 200;          /* periodo processo 2 */
int	t3 = 300;          /* periodo processo 3 */

int	y[3] = {150, 300, 450};     /* posizione processi   */

char	talk[3][50] = { "Sono PROC1 e stampo un carattere ogni 100 ms",
			"Sono PROC2 e stampo un carattere ogni 200 ms",
			"Sono PROC3 e stampo un carattere ogni 300 ms"};
int	leng;
SEM	mutex;		/* semaforo mutua escl. */

/***************************************************************/

TASK	ego(int i)
{
char	s[2];
int	x;
int	j = 0;
int	w;

	x = X0;
	s[1] = 0;

	while (1) {
		s[0] = talk[i][j];
		sem_wait(mutex, BLOCK);
//		grx_text("PROVA", 100,100,12,0);
		grx_text(s,x,y[i],12+i,0);
		sem_signal(mutex);
		x += 8;
		if (++j == leng) {
			j = 0;
			x = X0;
			y[i] += 8;
		}
		task_endcycle();
	}
}


/****************************************************************/

void my_end(KEY_EVT* e)
{
	grx_close();
	cprintf("Ctrl-Brk pressed!\n");
	sys_end();
	exit(1);
}

/****************************** MAIN ******************************/

void	main()
{
PID	pid1, pid2, pid3;
SYS_PARMS s = BASE_SYS;
MODEL	m = BASE_MODEL;
KEYB_PARMS keyb=BASE_KEYB;   
int	mode;
KEY_EVT	emerg;

	leng = 0;
	while (talk[0][leng] != 0) leng++;
	
	sys_def_nocheck(s);
	sys_init(&s);
	mutex = sem_create(1);
        keyb_def_map(keyb,itaMap);
        keyb_init(&keyb);
	emerg.ascii = 'x';
	emerg.scan = KEY_X;
	emerg.flag = ALTL_BIT;
	keyb_hook(emerg,my_end);

	if (grx_open(800, 600, 8) < 0) {
	    cprintf("GRX Err\n");
	    sys_abort(300);
	}
	cprintf("scheda ok\n");
/*    if (grx_init() < 1) {
	sys_abort(400);
    }

    mode = grx_getmode(800, 600, 8);
cprintf("Modenum:%d %u %x\n", mode, mode, mode);

    if (grx_setmode(mode) < 0) {
	sys_abort(401);
    }
*/
	task_def_group(m, 1);

	task_def_arg(m, 0);
	task_def_wcet(m, 50);
	pid1 = task_create("ego1", ego, HARD, PERIODIC, t1, &m);
	
	task_def_arg(m, 1);
	task_def_wcet(m, 50);
	pid2 = task_create("ego2", ego, HARD, PERIODIC, t2, &m);

	task_def_arg(m, 2);
	task_def_wcet(m, 50);
	pid3 = task_create("ego3", ego, HARD, PERIODIC, t3, &m);

	group_activate(1);

	keyb_getchar();

	group_kill(1);

	grx_close();

	sys_end();
}

/****************************************************************/
