/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/

/* File: 	MDEMO.C						*/
/* Revision:	1.0						*/

#include <string.h>
#include <stdlib.h>
#include <cons.h>

#include "hartik.h"
#include "keyb.h"
#include "mouse.h"

static int oldx = 0;
static int oldy = 0;
static char mouse_cursor[] = {' ','x','1','2','3'};
static char mouse_color[] = {BLACK,GREEN,RED,RED,RED};

void my_handler(MOUSE_EVT *evt)
{
    #ifdef __DEBUG__    
    char str[40];
    sprintf(str,"Status: %2d %2d %2d",evt->x,evt->y,evt->buttons);
    puts_xy(0,8,WHITE,str);
    #endif
    putc_xy(oldx,oldy,mouse_color[0],mouse_cursor[0]);
    oldx = evt->x; oldy = evt->y;
    putc_xy(evt->x,evt->y,mouse_color[1 + evt->buttons],
	    mouse_cursor[1 + evt->buttons]);
}

int main()
{
    char c,str[80];
    PID p1;
    SYS_PARMS sp = BASE_SYS;
    int t = 5;

    sys_def_nocheck(sp);
    sys_init(&sp);
    keyb_init(NULL);
    clear();
    
    cprintf("HARTIK Serial Mouse demo\nPress [x] to exit\n");
    cprintf("Mouse limits set to %i,%i,%i,%i\n",
	    20,4,cons_columns-1,cons_rows-1);
    cprintf("My Handler : %p \n",&my_handler);
   
    mouse_init(NULL);
    mouse_limit(20,4,cons_columns-1,cons_rows-1);
    mouse_position(50,12);
    oldx = 50; oldy = 12;
    mouse_hook(my_handler);
    
    while ((c = keyb_getchar()) != 'x') {
	switch(c) {
	    case '+' :  if (t < 100) t++;
	    		else break;
	    		mouse_threshold(t);
			sprintf(str,"Threshold : %2d",t);
			puts_xy(0,7,WHITE,str);
			break;
	    case '-' :  if (t > 2) t--;
	    		else break;
	    		mouse_threshold(t);
			sprintf(str,"Threshold : %2d",t);
			puts_xy(0,7,WHITE,str);
			break;
	}
    }
    mouse_end();
    clear();
    sys_end();
    return 0;
}
