/* Project:     HARTIK 3.0 Sound Library                        */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni                                      */
/* Date:        1/12/97						*/

/* File:        SoundDemo1.C                                    */
/* Revision:    1.0                                             */

/*
   Simple demo for the HARTIK SoundLib: it only samples and then plays
   something from the sound card mic using double buffering mode
*/                                              

#include <hartik.h>
#include <sound.h>

/*
    Buffer for the samples:
    If you work with 16 bit system, we can only handle
    64KB at once! No problem with 32 bit systems...
*/

#ifdef __386__
#define SND_BUF_DIM	0x1FFFF
#else
#define SND_BUF_DIM	0xFFFF
#endif

BYTE buff[SND_BUF_DIM];

void main(void)
{
    SYS_PARMS sp = BASE_SYS;

    sys_init(&sp);
    keyb_init(SOFT,100);
    clear();

    /*
       Init the sound card with a DMA buffer of 4000H bytes (the second
       parameter tells that the system tick is 1000 usec
    */
    sound_init(0x4000, 1000);
    sound_info();

    cprintf("Recording...\n");
    sound_sample(buff, 44000, SND_BUF_DIM/2, DMA_OP| PCM8 | SYNCH);
    /* Wait for the end of the operation */
    sound_wait();
    cprintf("Recorded...\n");

    cprintf("Playing...\n");
    sound_play(buff, 44000, SND_BUF_DIM/2, DMA_OP | PCM8 | SYNCH);
    sound_wait();
    cprintf("Played...\n");

    sys_end();
}
