#include <string.h>
#include <stdlib.h>
#include <cons.h>

#include "hartik.h"
#include "cons.h"
#include "crtwin.h"
#include "keyb.h"

typedef struct {
    int x,y,dx,dy;
} MSG;

#define INIT_X  1 
#define INIT_Y  1


TASK ball1(void)
{
    PORT pin,pout2,pout3;
    MSG m;
    WIN w;
    int x,y;
    int dx,dy;

    win_init(&w,0,0,79,10);
    win_frame(&w,BLACK,WHITE,"Ball",2);
    pin = port_create("ball1",sizeof(MSG),1,MAILBOX,READ);
    pout2 = port_connect("ball2",sizeof(MSG),MAILBOX,WRITE);
    pout3 = port_connect("ball3",sizeof(MSG),MAILBOX,WRITE);
    x = INIT_X;		/* This task has the ball initially */
    y = INIT_Y;
    dx = 1;
    dy = 1;
    while (1) {
	/* First Step : move the ball... */
	while ( y < 10 ) {
	    if (x > 0 && x < 79 && y > 0 && y < 10) putc_xy(x,y,WHITE,' ');
	    x += dx;
	    y += dy;
	    if (y <= 1) dy = +1;
	    if (x <= 1) dx = +1;
	    if (x >= 78) dx = -1;
	    if ((y < 10) && (x > 0) && (x < 79))
	        putc_xy(x,y,WHITE,'*');
	    else {
		y += 2*dy;
		x += 2*dx;
		if (x < 40) {
		    m.x = x;
		    m.y = y;
		    m.dx = dx;
		    m.dy = dy;
		    port_send(pout2,(BYTE *)(&m),BLOCK);
		}
		else {
		    m.x = x;
		    m.y = y;
		    m.dx = dx;
		    m.dy = dy;
		    port_send(pout3,(BYTE *)(&m),BLOCK);
		}
	    }
	    task_endcycle();
	}
	/* Now wait for next time the ball comes in the win...*/
	port_receive(pin,(BYTE *)(&m),BLOCK);
	x = m.x;
	y = m.y;
	dx = m.dx;
	dy = m.dy;
    }
}
    
TASK ball2(void)
{
    PORT pin,pout1,pout3;
    MSG m;
    WIN w;
    int x,y;
    int dx,dy;

    win_init(&w,0,11,40,10);
    win_frame(&w,BLACK,WHITE,"Ball",2);
    pin = port_create("ball2",sizeof(MSG),1,MAILBOX,READ);
    pout1 = port_connect("ball1",sizeof(MSG),MAILBOX,WRITE);
    pout3 = port_connect("ball3",sizeof(MSG),MAILBOX,WRITE);
    while (1) {
	/* First Step : wait for the ball... */
	port_receive(pin,(BYTE *)(&m),BLOCK);
	x = m.x;
	y = m.y;
	dy = m.dy;
	dx = m.dx;
	while (( y > 11 ) && (x < 40)) {
	    if (x > 0 && x < 40 && y > 11 && y < 21) putc_xy(x,y,WHITE,' ');
	    x += dx;
	    y += dy;
	    if (y >= 20) dy = -1;
	    if (x <= 1) dx = +1;
	    if ((y > 11) && (y < 21) && (x > 0) && (x < 40))
	        putc_xy(x,y,WHITE,'*');
	    else {
		if (x >= 40) {
		    x += 2*dx;
		    y += 2*dy;
		    m.x = x;
		    m.y = y;
		    m.dy = dy;
		    m.dx = dx;
		    port_send(pout3,(BYTE *)(&m),BLOCK);
		}
		else if (y <= 11) {
		    x += 2*dx;
		    y += 2*dy;
		    m.x = x;
		    m.y = y;
		    m.dx = dx;
		    m.dy = dy;
		    port_send(pout1,(BYTE *)(&m),BLOCK);
		}
	    }
	    task_endcycle();
	}
    }
}

TASK ball3(void)
{
    PORT pin,pout1,pout2;
    MSG m;
    WIN w;
    int x,y;
    int dx,dy;

    win_init(&w,41,11,38,10);
    win_frame(&w,BLACK,WHITE,"Ball",2);
    pin = port_create("ball3",sizeof(MSG),1,MAILBOX,READ);
    pout1 = port_connect("ball1",sizeof(MSG),MAILBOX,WRITE);
    pout2 = port_connect("ball2",sizeof(MSG),MAILBOX,WRITE);
    while (1) {
	/* First Step : wait for the ball... */
	port_receive(pin,(BYTE *)(&m),BLOCK);
	x = m.x;
	y = m.y;
	dy = m.dy;
	dx = m.dx;
	while (( y > 11 ) && (x > 41)) {
	    putc_xy(x,y,WHITE,' ');
	    x += dx;
	    y += dy;
	    if (y >= 20) dy = -1;
	    if (x >= 78) dx = -1;
	    if ((y > 11) && (y < 21) && (x < 79) && (x > 41))
	        putc_xy(x,y,WHITE,'*');
	    else {
		if (x <= 41) {
		    x += 2*dx;
		    y += 2*dy;
		    m.x = x;
		    m.y = y;
		    m.dy = dy;
		    m.dx = dx;
		    port_send(pout2,(BYTE *)(&m),BLOCK);
		}
		else if (y <= 11) {
		    x += 2*dx;
		    y += 2*dy;
		    m.x = x;
		    m.y = y;
		    m.dx = dx;
		    m.dy = dy;
		    port_send(pout1,(BYTE *)(&m),BLOCK);
		}
	    }
	    task_endcycle();
	}
    }
}

void main()
{
    PID b1,b2,b3;
    char c,goon;
    long per = 40;    
    SYS_PARMS sp = BASE_SYS;

    sys_def_tick(sp,300,uSec);
    sys_init(&sp);

    keyb_init(NULL);
    cursor_off();
    clear();
    puts_xy(0,22,WHITE,"Press ESC to exit demo...");
    
    b1 = task_create("b1",ball1,NRT,PERIODIC,per,NULL);
    b2 = task_create("b2",ball2,NRT,PERIODIC,per,NULL);
    b3 = task_create("b3",ball3,NRT,PERIODIC,per,NULL);
    task_activate(b1);
    task_activate(b2);
    task_activate(b3);

    goon = TRUE;
    while(goon) {
	c = keyb_getchar();
	//for (per = 0; per < 0xFFFFFF; per++);
	//c = ESC;
	switch (c) {
	    case ESC :	goon = FALSE;
	    		break;
	    case '+' :	per += 10;
	    		if (per > 300) per = 300;
			proc_table[b1].period = per;
			proc_table[b2].period = per;
			proc_table[b3].period = per;
			printf_xy(0,0,WHITE,"Damping factor : %3ld",per);
			break;
	    case '-' :	per -= 10;
	    		if (per < 50) per = 50;
			proc_table[b1].period = per;
			proc_table[b2].period = per;
			proc_table[b3].period = per;
			printf_xy(0,0,WHITE,"Damping factor : %3ld",per);
			break;
	}
    }
    cursor_std();
    clear();
    sys_end();
    sys_status(NORM_STATUS);
}
