/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/

/* File: 	Cons.H						*/
/* Revision:	1.0						*/

/* GNU-C COFF support */

#ifndef __CONS_H__
#define __CONS_H__

#ifndef __HW_DEP_H__
#include "hw_dep.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif    

/* for reference only */
extern int cons_columns; /* number of screen columns */
extern int cons_rows;    /* number of screen rows */

/* X-dependent Console Output functions			*/
/* Rememeber that console functions are NOT REENTRANT   */
/* The console must be considered a preemtable resource */
/* File : Cons.C					*/

void set_visual_page(int page);
void set_active_page(int page);
int get_visual_page(void);
int get_active_page(void);
void place(int x,int y);
void cursor(int start,int end);
void _clear(char c,char attr,int x1,int y1,int x2,int y2);
void clear(void);
void _scroll(char attr,int x1,int y1,int x2,int y2);
void scroll(void);
void bios_save(void);
void bios_restore(void);
void cputc(char c);
void cputs(char *s);
int  cprintf(char *fmt,...) __attribute__((format(printf,1,2)));

/* These functions allow direct access to video RAM */
/* Hence you can use it without the explicit use of */
/* a resource manager				    */
/* File : Cons.C				    */

void putc_xy(int x,int y,char attr,char c);
char getc_xy(int x,int y,char *attr,char *c);
void puts_xy(int x,int y,char attr,char *s);
int printf_xy(int x,int y,char attr, char *fmt,...) __attribute__((format(printf,4,5)));

/* These are simple useful macro! */
#define HOME()		place(0,0);
#define cursor_blob()	cursor(0,15);
#define cursor_off()	cursor(16,16);
#define cursor_std()	cursor(14,15);
#define NL()		cputc('\n');

/* Text mode color definitions */

#define BLACK		0
#define BLUE		1
#define GREEN		2
#define CYAN		3
#define RED		4
#define MAGENTA		5
#define BROWN		6
#define LIGHTGRAY	7
#define DARKGRAY	8
#define LIGHTBLUE	9
#define LIGHTGREEN	10
#define LIGHTCYAN	11
#define LIGHTRED	12
#define LIGHTMAGENTA	13
#define YELLOW 		14
#define WHITE		15

#ifdef __cplusplus
};
#endif

#endif

