/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Giuseppe Lipari                                 */
/* Date:        2/7/96                                          */

/* File: 	CrtWin.H					*/
/* Revision:    1.0						*/

#ifndef __CRTWIN_H__
#define __CRTWIN_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    /* Window location & size */
    int x,y,dx,dy;      
    /* Cursor position inside the window */
    int px,py;
} WIN;

/*
   The window layout is depicted here
   
      (x,y)                      (x+dx,y)
	  ************************
	  *(0,0)                 *
	  *                      *
	  *                      *
	  *           (dx-1,dy-1)*
	  ************************
				 (x+dx,y+dy)

    Inside the window relative coords are used!
*/

#define SINGLE_FRAME	1
#define DOUBLE_FRAME	2
#define NO_FRAME	0

void win_init(WIN *w,int x, int y, int dx, int dy);
void win_frame(WIN *w,BYTE bcol,BYTE fcol,char *title,BYTE type);
void win_scroll(WIN *w);
void win_clear(WIN *w);
void win_puts(WIN *w, char *s);
int win_gets(WIN *w, char *s,int l);

void cons_init(void);

#ifdef __cplusplus
};
#endif

#endif
