/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Gerardo Lamastra                                */
/*              Giuseppe Lipari                                 */
/* Date:        1/7/96                                          */

/* File:        Hw_Dep.H                                        */
/* Revision:    1.0                                             */
/* Date:	14/3/97						*/

/* Hardware dependent architecture details			*/
/* $HEADER+							*/

#ifndef __HW_DEP_H__
#define __HW_DEP_H__

#if !defined(__GNU__) && !defined(__LINUX__)
/*
   Just some dummy #define for compatibility
*/
#define __attribute__(x)
#define __format__(x,y,z)
#endif

#if !defined(__WC32__) && !defined(__WC16__)
/*
   Just some dummy #define for compatibility for GNU
*/
#define __interrupt
#define __cdecl
#endif

#if  defined(__WC32__)
#define __VM_ARCH__ "32/Watcom C/ELF"
#include "hw386.h"	/* 386 & upper processors under Watcom C*/
#elif defined(__WC16__)
#define __VM_ARCH__ "16/Watcom C/.MZ"
#include "hw86.h"	/* 86 & upper processors under Watcom C-16*/
#elif defined(__GNU__)
#define __VM_ARCH__ "32/DJGPP C/COFF"
#include "hw386gnu.h"	/* 386 & upper processors under GNU C */
#elif defined(__LINUX__)
#define __VM_ARCH__ "32/LINUX CrossCompiled/ELF"
#include "hw386gnu.h" /* 386 & upper processors under GNU-C/LINUX */
#else
#error Architecture Undefined!
#endif

#endif /* __HW_DEP_H__ */

