/* Project:     HARTIK 3.0 Network Library                      */

/* Description: Hard Real TIme Kernel for 8086 compatible       */

/* Author:      Luca Abeni					*/

/* Date:        4/12/1997                                       */



/* File:        Net.H                                           */

/* Revision:    1.00                                            */



#ifndef __NET_H__

#define __NET_H__



#ifdef __cplusplus

extern "C" {

#endif



/***************************************************************************/

/*									   */

/*				NetInit interface			   */

/*									   */

/***************************************************************************/

#define NET_MAX_PROTOCOLS	10

#define TXTASK 1
#define TXMEM  0
#define LOOPBACK 2
		
#define net_setmode(m,mode) m.lowlevparm=mode



typedef struct protocol {

    void (*initfun)(void *parm);

    void *initparms;

} PROTOCOL;

    

typedef struct net_model {

    int lowlevparm;

    int numprotocol;

    struct protocol protocol[NET_MAX_PROTOCOLS];

} NET_MODEL;



extern struct net_model net_base /*= {0, 0, {NULL, NULL, NULL, NULL, NULL, NULL, NULL,

    				  NULL, NULL, NULL, NULL, NULL, NULL, NULL,

    				  NULL, NULL, NULL, NULL, NULL, NULL}}*/;



void set(struct net_model *m);

void setprotocol(struct net_model *m, void (*initfun)(void *parm), void *initparms);

int net_init(struct net_model *m);



/* The UDP/IP stack definition now are in the exported header "UDPIP.H" */



#ifdef __cplusplus

};

#endif



#endif

