/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Gerardo Lamastra                                */
/*              Giuseppe Lipari                                 */
/* Date:        9/5/96                                          */

/* File:        Cabs.H                  */
/* Revision:    1.1                     */
/* Date:	14/3/97			*/

/* $HEADER+ */

#ifndef __CAB_H__
#define __CAB_H__

typedef int CAB;

/* User level CAB primitives */
CAB cab_create(char *name, int dim_mes, BYTE num_mes);
char *cab_reserve(CAB id);
int cab_putmes(CAB id, char *pbuf);
char *cab_getmes(CAB id);
int cab_unget(CAB id, char *pun_mes);
void cab_delete(CAB id);

/* Cab exception codes */

#define CAB_UNVALID_MSG_NUM     110
#define CAB_NO_MORE_ENTRY       111
#define CAB_TOO_MUCH_MSG        112
#define CAB_UNVALID_ID          113
#define CAB_CLOSED              114

#endif /* __CAB_H__ */

