/* Project:     HARTIK 3.0                                      */
/* Description: The Portable Hard Real TIme Kernel              */
/* Author:      Gerardo Lamastra                                */
/* Date:        1/7/96                                          */

/* CVS $Id: const.h,v 1.3 1999/06/04 10:53:00 massy Exp $ */

/* File:        Const.H                                         */
/* Revision:    3.0                                             */
/* Date:        14/3/97                                         */

/* Main system constant                                         */
/* This file is used also at assembly level,to have unique      */
/* defintion and avoid mess!                                    */

/* $HEADER+                                                     */

#ifndef __CONST_H__
#define __CONST_H__

/* $HEADER-             	                                        */
/* -------------------------------------------------------------------- */
/* These constant can be freely changed to customize the kernel         */
/* -------------------------------------------------------------------- */
/* $HEADER+ 		                                                */

#define MAX_PROC        66U             /* Maximum number of tasks      */
#define MAX_RESOURCE    20U             /* SRP Shared resources         */
#define MAX_EXITFUNC    20U             /* Automatic exit functions     */
#define STACK_SIZE      4096U           /* Stack size in bytes          */
#define MAX_SEM         50U             /* Maximum number of semaphores */
#define MAX_EXC         256U            /* Exception handlers           */
#define MAX_INT         16U             /* Interrupt entries            */

#define MAX_CAB         10U             /* Maximum number of CABs       */

#define MAX_PORT        15U             /* Maximum number of ports      */   
#define MAX_PORT_INT    30U             /* Max num. of port connections */ 
#define MAX_PORT_NAME   20U             /* Maximum port name length     */
#define MAX_HASH_ENTRY  MAX_PORT        /* More port stuff              */

#define MAX_CPRINT_BUF 512U             /* Length of cprintf() buffer   */     

/* $HEADER- 		                                                */
/* -------------------------------------------------------------------- */
/* End of user customazable constants                                   */
/* -------------------------------------------------------------------- */
/* $HEADER+ 		                                                */

#define MAX_DLINE       4294967295U     /* Maximum deadline             */
#define MAX_PRIORITY    255U            /* Maximum NRT priority         */

#define MAIN_INDEX      MAX_PROC-2U
#define MAIN_PRIORITY   MAX_PRIORITY/2U
#define DUMMY_INDEX     MAX_PROC-1U
#define DUMMY_PRIORITY  MAX_PRIORITY

/* Time unit definitions */

#define mSec    1
#define uSec    0
#define MILLI   1
#define MICRO   0

/* TYPE attributes */

#define PERIODIC        1
#define APERIODIC       2

/* PCLASS attribute */

#define HARD            1
#define FIRM            2
/*#define SOFT            3*/
#define NRT             4
#define SOFT         5	/* For the moment, this is the name of the
				   CBS tasks... --- Luca */

/* STATUS attribute */

#define FREE            0
#define EXE             1
#define READY           2
#define SLEEP           3
#define IDLE            4
#define WAIT            5
#define LOBBY           6
#define LOBBY_READY     7
#define ENDING          8
#define ZOMBIE          9

/* Blocking attribute for semaphore & port operations */

#define BLOCK           1
#define NON_BLOCK       0

/* C stuff */


#ifndef NIL
#define NIL     -1                    /* integer unvalid value */
#endif

#ifndef NULL
    #define NULL    ((void *)(0L))        /* pointer unvalid value */
#endif

#define DEFAULT ((unsigned long)(-1)) /* used for default params */

#endif /* __CONST_H__ */

