/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 8086 compatible	*/
/* Author:	Giuseppe Lipari					*/
/* Date:	9/5/96 						*/

/* File: 	Port.H						*/
/* Revision:	2.0						*/
/* Date:	14/3/97						*/

/* Port header file 						*/
/* $HEADER+							*/

#ifndef __PORT_H__
#define __PORT_H__

/* $HEADER-    */
#ifndef __HW_DEP_H__
#include "hw_dep.h"
#endif
/* $HEADER+    */

typedef	short PORT;

#define STREAM		1
#define MAILBOX		2
#define STICK		3

#define	READ		0
#define WRITE		1

/* Debugging functions */
void print_port(void);
void port_write(PORT p);
int  isBlocked(PID i);

/* User level port primitives */
PORT port_create(char *name, int dim_mes, int num_mes, BYTE type, BYTE access);
PORT port_connect(char *name, int dim_mes, BYTE type, BYTE access);
void port_delete(PORT p);
void port_disconnect(PORT p);

WORD port_send(PORT p,void *m,BYTE wait);
WORD port_receive(PORT p,void *m,BYTE wait);

/* Port exceptions codes */

#define PORT_NO_MORE_DESCR 	90
#define PORT_NO_MORE_INTERF	91
#define PORT_NO_MORE_HASHENTRY	92
#define PORT_ALREADY_OPEN	93
#define PORT_2_CONNECT		94
#define PORT_WRONG_TYPE		95
#define PORT_UNSUPPORTED_ACC	96
#define PORT_INCOMPAT_MESSAGE	97
#define PORT_WRONG_OP		98
#define PORT_ALREADY_CLOSED	99
#define PORT_UNVALID_DESCR	100

#endif /* __PORT_H__ */

