/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Gerardo Lamastra                                */
/*              Giuseppe Lipari                                 */
/* Date:        1/7/96                                          */

/* File: 	Srp.H 						*/
/* Revision:    1.0 	                                        */
/* Date:	14/7/97						*/

#ifndef __SRP_H__
#define __SRP_H__

#ifndef __KERN_H__
#include "kern.h"
#endif

#define MAX_CEILING	0xFFFFFFFF

typedef struct {
    DWORD section[MAX_RESOURCE];
    PID nxt;
} SRP_ENTRY;

extern DWORD new_ceiling[];
extern DWORD res_ceiling[];
extern SRP_ENTRY srp_block[];
extern PID srp_first;
extern DWORD sys_ceiling;

void srp_calc_ceiling(DWORD *tmp_ceiling);
void srp_init(void);
void srp_insert(PID p);
void srp_extract(PID p);
int  srp_stack_empty(void);
int  srp_guarantee(PID p);
void srp_endtask(PID p);
void srp_starttask(PID p);

/* It seems that these are the only two functions which must be */
/* visible at user level programmers				*/

/* $HEADER+ */

void srp_wait(int resource);
void srp_signal(int resource);

/* $HEADER- */

#endif /* __SRP_H__ */
