/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/

/* File: 	Mem.H						*/
/* Revision:	1.0						*/

/* GNU-C COFF support */

#ifndef __MEM_H__
#define __MEM_H__

#ifdef __cplusplus
extern "C" {
#endif    

/* Various string manipulation functions */

/* Assembler low level routines 	*/
/* File: Mem.S			        */

#ifndef NULL
    #define NULL 0L
#endif

#ifndef __HW_DEP_H__
    #include "hw_dep.h"
#endif

#ifndef __LINUX__
void memcpy(void *dest,void *src,unsigned n);
int  memcmp(void *dest,void *src,unsigned n);
void memset(void *dest,char v,unsigned n);
int  memchr(void *dest,char v,unsigned n);
void lmemcpy(LIN_ADDR dest,LIN_ADDR src,unsigned n);
int  lmemcmp(LIN_ADDR dest,LIN_ADDR src,unsigned n);
void lmemset(LIN_ADDR dest,char v,unsigned n);
int  lmemchr(LIN_ADDR dest,char v,unsigned n);
void __cdecl fmemcpy(unsigned short ds,unsigned long dof,unsigned short ss,unsigned long sof,unsigned n);
#else
void _memcpy(void *dest,void *src,unsigned n);
int  _memcmp(void *dest,void *src,unsigned n);
void _memset(void *dest,char v,unsigned n);
int  _memscn(void *dest,char v,unsigned n);
void _lmemcpy(unsigned long dest,unsigned long src,unsigned n);
int  _lmemcmp(unsigned long dest,unsigned long src,unsigned n);
void _lmemset(unsigned long dest,char v,unsigned n);
int  _lmemchr(unsigned long dest,char v,unsigned n);
void __cdecl fmemcpy(unsigned short ds,unsigned long dof,
	unsigned short ss,unsigned long sof,unsigned n);

void memcpy(void *dest,void *src,unsigned n) __attribute__((weak,alias("_memcpy")));
int  memcmp(void *dest,void *src,unsigned n) __attribute__((weak,alias("_memcmp")));
void memset(void *dest,char v,unsigned n) __attribute__((weak,alias("_memset")));
int  memchr(void *dest,char v,unsigned n) __attribute__((weak,alias("_memscn")));
void lmemcpy(unsigned long dest,unsigned long src,unsigned n) __attribute__((weak,alias("_lmemcpy")));
int  lmemcmp(unsigned long dest,unsigned long src,unsigned n) __attribute__((weak,alias("_lmemcmp")));
void lmemset(unsigned long dest,char v,unsigned n) __attribute__((weak,alias("_lmemset")));
int  lmemchr(unsigned long dest,char v,unsigned n) __attribute__((weak,alias("_memchr")));
void __cdecl fmemcpy(unsigned short ds,unsigned long dof,
	unsigned short ss,unsigned long sof,unsigned n) __attribute__((weak,alias("_fmemcpy")));
#endif


#ifdef __cplusplus
};
#endif

#endif

