/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/

/* File: 	String.H					*/
/* Revision:	1.0						*/

/* GNU-C COFF support */

#ifndef __STRING_H__
#define __STRING_H__

#ifndef __HW_DEP_H__
#include "hw_dep.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif    

#ifndef _STDARG_H_INCLUDED
    #include <stdarg.h>
#endif

#ifndef NULL
    #define NULL 0L
#endif

/* Various string manipulation functions */

/* File: String.C		*/

char *strcpy(char *dst,char *src);
char *strncpy(char *dst,char *src,int n);
int strcmp(char *s1,char *s2);
int strncmp(char *s1,char *s2,int n);
int strlen(char *s);
char *strscn(char *s,char *pattern);
char *strchr(char *s,int c);
char *strupr(char *s);
char *strlwr(char *s);
char *strcat(char *dst,char *src);
char _toupper(char c);
char _tolower(char c);
int _tonumber(char c);
char _todigit(int c);
int _isnumber(char c,int base);

/* String conversion functions  	*/
/* File: StrConv.C			*/

long strtoi(char *s,int base,char **scan_end);
unsigned long strtou(char *s,int base,char **scan_end);
double strtod(char *s,char **scan_end);

/* StdLib Macro */

#define atof(s)	strtod(s,NULL);
#define atoi(s)	strtoi(s,10,NULL);
#define atou(s)	strtu(s,10,NULL);

unsigned ucvt(unsigned long v,char buffer[],int base,int prec,int flag);
unsigned dcvt(long v,char *buffer,int base,int prec,int flag);
unsigned fcvt(double v,char *buffer,int width,int prec,int flag);
unsigned ecvt(double v,char *buffer,int width,int prec,int flag);
unsigned gcvt(double v,char *buffer,int width,int prec,int flag);

int vsprintf(char *buf,char *fmt,va_list parms);
int sprintf(char *buf,char *fmt,...) __attribute__((__format__(printf,2,3)));
int vsscanf(char *buf,char *fmt,va_list parms);
int sscanf(char *buf,char *fmt,...) __attribute__((__format__(scanf,2,3)));

/* Flag bit settings */
#define RESPECT_WIDTH	1  /* Fixed width wanted 	*/
#define ADD_PLUS	2  /* Add + for positive/floats */
#define SPACE_PAD	4  /* Padding possibility	*/
#define ZERO_PAD	8
#define LEFT_PAD 	16

#ifdef __cplusplus
};
#endif

#endif

