/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/

/* File: 	XDos.H						*/
/* Revision:	1.0						*/

/* DOS -- X interfacing functions */

#ifndef __XDOS_H__
#define __XDOS_H__

#ifdef __cplusplus
extern "C" {
#endif    

#ifndef __HW_DEP_H__
    #include "hw_dep.h"
#endif

#ifdef __WC16__
    /* DOS FileSystem interface	  				*/
    /* Why Bother? Just remap stdio names onto HARTIK ones 	*/
    #ifndef _STDIO_H_INCLUDED
    #include <stdio.h>
    #endif    
    #define DOS_FILE		FILE
    #define DOS_fopen(n,a)	fopen(n,a)
    #define DOS_fclose(f)	fclose(f)
    #define DOS_fread(b,s,n,f)	fread(b,s,n,f)
    #define DOS_fwrite(b,s,n,f) fwrite(b,s,n,f)
#else
    #ifndef __XSYS_H__
	#include "xsys.h"
    #endif
    
    /* DOS memory allocation function */
    /* File: XDosM.C		  */
    
    LIN_ADDR DOS_alloc(DWORD size);
    int DOS_free(LIN_ADDR ap,DWORD size);
    
    /* DOS FileSystem interface	  */
    /* File: XDosF.C		  */
    
    typedef struct {
	LIN_ADDR buf;
	LIN_ADDR n1;
	char    n2[80];
	BYTE    mode,index;
	DWORD   handle,offset;
    } DOS_FILE;
    
    DOS_FILE *DOS_fopen(char *name, char *mode);
    void DOS_fclose(DOS_FILE *f);
    DWORD DOS_fread(void *buf,DWORD size,DWORD num,DOS_FILE *f);
    DWORD DOS_getline(void *abuf, DWORD count, int ch, DOS_FILE *f);
    DWORD DOS_fwrite(void *buf,DWORD size,DWORD num,DOS_FILE *f);
    unsigned DOS_ferror(void);

    int DOS_fgetc(char   *ptr, DOS_FILE *f);
    int DOS_fgeti(int    *ptr, DOS_FILE *f);
    int DOS_fgetf(double *ptr, DOS_FILE *f);
    
#endif /* __16BIT_EMULATION__ */

#ifdef __cplusplus
};
#endif

#endif

