/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/

/* File: 	XSys.H						*/
/* Revision:	1.0						*/

/* changed to support __SAFEXBIOS__ (see xbios.c) by Massy */

#ifndef __XSYS_H__
#define __XSYS_H__

#include <config.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __HW_DEP_H__
    #include "hw_dep.h"
#endif

#define DOS_OFF(x)	(x & 0x000F)
#define DOS_SEG(x)	((x & 0xFFFF0) >> 4)


/* Assembler functions 	*/
/* File: XSys.Asm	*/

#ifndef __LINUX__
void _exit(int code) __attribute__((noreturn));
#else
void __exit(int code) __attribute__((noreturn)); 
void _exit(int code) __attribute__((noreturn,weak,alias("__exit")));
#endif

#ifdef __NO_INLINE__
    unsigned char inp(unsigned port);
    void outp(unsigned port,unsigned char value);
    unsigned short inpw(unsigned port);
    void outpw(unsigned port,unsigned short value);
    unsigned long inpd(unsigned port);
    void outpd(unsigned port,unsigned long value);
    void enable(void);
    void disable(void);
#endif

/* Low level X-dependent functions */
/* File : XSys.C		   */

LIN_ADDR appl2linear(void *p);
void *linear2appl(LIN_ADDR a);
void IDT_place(BYTE num,void (__cdecl *handler)(void));
void GDT_place(WORD sel,DWORD base,DWORD lim,BYTE acc,BYTE gran);
DWORD GDT_read(WORD sel,DWORD *lim,BYTE *acc,BYTE *gran);
LIN_ADDR addr2linear(unsigned short sel,unsigned long offset);
WORD X_version(void);
void X_meminfo(DWORD *b1,DWORD *s1,DWORD *b2,DWORD *s2);
void check_addr(void *addr,char *caller);
void exit(int code) __attribute__ ((noreturn));

#ifdef __WC16__
/* We use emulation! Look at wc16\bioscomp.c */
#include <i86.h>
typedef union REGS X_REGS16;
typedef struct SREGS X_SREGS16;
#endif
void X_callBIOS(int service,X_REGS16 *in,X_REGS16 *out,X_SREGS16 *s);

#ifdef __SAFEXBIOS__
void xbios_initfun(void);
int  xbios_regfun(void (*fun)(void), int when);
#endif
   
/* The _X_info structure is filled by X startup code  */
/* The X startup code is contained into X0.ASM & X1.C */
extern struct info *_X_info;

#ifdef __cpluplus
};
#endif

#endif

