/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Gerardo Lamastra                                */
/*              Giuseppe Lipari                                 */
/* Date:        1/10/96                                         */

/* File:        KernStub.C                                      */
/* Revision:    1.0                                             */

/* Simple debug stub for the kernel                             */

/* Nothing needs to be included, as this is included into Kern.C */

BADDR *video;

/* Simple handler management */

void kfast(void)
{
    BYTE dato;
    dato = VM_in(0x60); /* Input datum */
}

TASK ktask(void)
{
    *(video + 140) = 0;
    *(video + 141) = 4;

    for(;;) {
	*(video + 140) ^= 'R';
	task_endcycle();
    }
}

/* Just a pair of task ... */

TASK task1(void)
{
    *(video + 4) = 0;
    FOREVER {
	*(video + 4) ^= '1';
	task_endcycle();
    }
}

TASK task2(void)
{
    *(video + 8) = 0;
    FOREVER {
	*(video + 8) ^= '2';
	task_endcycle();
    }
}

void keyb_reset(void)
{
    int dato;
    VM_disable();
    /* send the reset command */
    VM_out(0x60,0xff);
    /* wait for ack 1 */
    while (!(VM_in(0x64) & 0x01));
    dato = VM_in(0x60);
    /* wait for ack 2 */
    while (!(VM_in(0x64) & 0x01));
    dato = VM_in(0x60);
    VM_enable();
}

void main()
{
    extern void keyb_handler(void);
    extern TASK keyProc(void);
    int p1,p2,kp;
    DWORD i;
    DWORD tick = 1000; 
    DWORD per1 = 10;
    DWORD per2 = 10;

    video = MK_FP(X_VIDEO_SEL,0);
    VM_printf("Time base (us)       : %lu\n",tick);
    VM_printf("Period Task 1 (tick) : %lu\n",per1);
    VM_printf("Period Task 2 (tick) : %lu\n",per2);

    sys_init(tick,uSec);
    p1 = task_create("Task #1",task1,HARD,PERIODIC,per1,NULL);
    p2 = task_create("Task #2",task2,HARD,PERIODIC,per2,NULL);
    kp = task_create("KT",keyProc,NRT,APERIODIC,10,NULL);
    install_handler(1,keyb_handler,kp);
    task_activate(p1);
    task_activate(p2);
    for (i = 0; i < 0x4FFFFF; i++);
    sys_end();
    VM_printf("Irqs : %d\n",irqs);
}


