/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Date:        2/7/96                                          */

/* File:           Load.C                                       */
/* Translated by : Luca Abeni		                        */
/* Revision:       1.0                                          */

#include "vm.h"
#include "kern.h"

static DWORD rif;

void load_init(void)
{
    SYS_FLAGS f;

    f = VM_save();
    rif = VM_timer_read();
    VM_restore(f);
}

void load_actual(struct load *l)
{
    DWORD this_time;
    SYS_FLAGS f;
    
    f = VM_save();
    this_time = VM_timer_read();
    VM_restore(f);
    l->rif = this_time - rif;
    rif = this_time;
    l->actual = -(proc_table[DUMMY_INDEX].cap + proc_table[MAIN_INDEX].cap);
    proc_table[DUMMY_INDEX].cap = 0;
    proc_table[MAIN_INDEX].cap = 0;
}
