; Project:     HARTIK 3.0                                       
; Description: Hard Real TIme Kernel for 8086 compatible        
; Author:      Gerardo Lamastra                                 
; Date:        9/5/96                                           

; File:         VmCPU16.Asm
; Revision:     1.0                                   

;
; The following code has been extracted by Intel AP-485
; Application Note: Intel Processor Identification with CPUID instruction
;

.model large

MCPUID	MACRO
	db 0fH
	db 0a2h
ENDM

pushd	MACRO x
	DB 	066h
	push	x
	ENDM

popd	MACRO x
	DB 	066h
	pop	x
	ENDM

vmcpu16_DATA	SEGMENT PARA PUBLIC 'FAR_DATA'
		ASSUME CS:vmcpu16_DATA

PUBLIC	_X86_cpu
PUBLIC	_X86_cpu
PUBLIC	_X86_fpu
PUBLIC	_X86_v86Flag
PUBLIC	_X86_cpuidFlag
PUBLIC	_X86_vendor
PUBLIC	_X86_signature
PUBLIC	_X86_features1
PUBLIC	_X86_features2
PUBLIC	_X86_features3

_X86_cpu	db	0
_X86_fpu	db	0
_X86_v86Flag	db	0
_X86_cpuidFlag	db	0
_X86_vendor	db	"------------",0
_X86_signature	dd	0
_X86_features1	dd	0
_X86_features2	dd	0
_X86_features3	dd	0
fpu_status	dw	0
vmcpu16_DATA	ENDS

vmcpu16_TEXT	SEGMENT USE16
		ASSUME CS:vmcpu16_TEXT,DS:NOTHING,ES:NOTHING

PUBLIC _X86_get_CPU
PUBLIC _X86_get_FPU

_X86_get_CPU 	PROC FAR
		pushf
		push	bx
		push	cx
		push	dx
		push	si
		push	di
				
		mov     ax,SEG vmcpu16_DATA
		mov     ds,ax
		pushf
		pop	ax
		mov	cx,ax
		and	ax,0fffh
		push	ax
		popf
		pushf
		pop	ax
		and 	ax,0f000h
		cmp	ax,0f000h
		mov	ds:_X86_cpu,1
		jne	chk286
		push	sp
		pop	dx
		cmp	dx,sp
		jne	endProc
		mov	ds:_X86_cpu,010h
		jmp	endProc

.286P
chk286:		smsw	ax
		and 	ax,1
		mov	_X86_v86Flag,al
		or	cx,0f000h
		push	cx
		popf
		pushf
		pop	ax
		and	ax,0f000h
		mov	ds:_X86_cpu,2
		jz	endProc
.386
chk386:		
		pushfd
		popd	eax
		mov	ecx,eax
		xor	eax,40000h
		pushd	eax
		popfd
		pushfd
		popd	eax
		xor	eax,ecx
		mov	ds:_X86_cpu,3
		jz	endProc1
		
		pushd	ecx
		popfd		

.486
chk486:		mov	ds:_X86_cpu,4
		mov	eax,ecx
		xor	eax,200000h
		pushd	eax
		popfd
		pushfd
		popd	eax
		xor	eax,ecx
		je	endProc1
		
		mov	ds:_X86_cpuidFlag,1
		mov	eax,0
		MCPUID
		mov	dword ptr ds:_X86_vendor,ebx
		mov	dword ptr ds:_X86_vendor[+4],edx
		mov	dword ptr ds:_X86_vendor[+8],ecx
		
		cmp	eax,1
		jl	endProc1
		mov	eax,1
		MCPUID
		mov	ds:_X86_signature,eax
		mov	ds:_X86_features1,ebx
		mov	ds:_X86_features2,ecx
		mov	ds:_X86_features3,edx
		shr	eax,8
		and	eax,0fh
		mov	ds:_X86_cpu, al

endProc1:	
		.8086					
endProc:	pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		popf
		ret
_X86_get_CPU ENDP

.387
_X86_get_FPU	PROC FAR
		mov     ax,SEG vmcpu16_DATA
		mov     ds,ax
		fninit
		mov	DS:fpu_status,5a5ah
		fnstsw	DS:fpu_status
		mov	ax,DS:fpu_status
		cmp	al,0
		mov	DS:_X86_fpu,0
		jne	endFPUProc

chkCW:		fnstcw 	DS:fpu_status
		mov	ax,DS:fpu_status
		and	ax,103fh
		cmp	ax,03fh
		mov	DS:_X86_fpu,0
		jne	endFPUProc
		mov	DS:_X86_fpu,1
		
chkInf:		cmp	DS:_X86_cpu,3
		jle	endFPUProc
		fld1
		fldz
		fdiv
		fld	st
		fchs
		fcompp
		fstsw	DS:fpu_status
		mov	DS:_X86_fpu,2
		sahf
		jz	endFPUProc
		mov	DS:_X86_fpu,3
endFPUProc:	ret
_X86_get_FPU	ENDP

vmcpu16_TEXT	ENDS

END
