; Project:     HARTIK 3.0                                       
; Description: Hard Real TIme Kernel for 8086 compatible        
; Author:      Gerardo Lamastra                                 
; Date:        9/5/96                                           

; File:         VmCPU32.Asm
; Revision:     1.0                                   

;
; The following code has been extracted by Intel AP-485
; Application Note: Intel Processor Identification with CPUID instruction
;

MCPUID	MACRO
	db 0fH
	db 0a2h
ENDM

.386p
		NAME    vmcpu32.asm

_DATA           SEGMENT DWORD PUBLIC USE32 'DATA'
PUBLIC	_X86_cpu
PUBLIC	_X86_cpu
PUBLIC	_X86_fpu
PUBLIC	_X86_v86Flag
PUBLIC	_X86_cpuidFlag
PUBLIC	_X86_vendor
PUBLIC	_X86_signature
PUBLIC	_X86_features1
PUBLIC	_X86_features2
PUBLIC	_X86_features3

_X86_cpu	db	0
_X86_fpu	db	0
_X86_v86Flag	db	0
_X86_cpuidFlag	db	0
_X86_vendor	db	"------------",0
_X86_signature	dd	0
_X86_features1	dd	0
_X86_features2	dd	0
_X86_features3	dd	0
fpu_status	dw	0
_DATA           ENDS

_TEXT           SEGMENT BYTE PUBLIC USE32 'CODE'
		ASSUME  CS:_TEXT,DS:DGROUP,SS:DGROUP

PUBLIC _X86_get_CPU
PUBLIC _X86_get_FPU

_X86_get_CPU 	PROC
		pushfd
		pop	eax
		mov	ecx,eax
		xor	eax,40000h
		push	eax
		popfd
		pushfd
		pop	eax
		xor	eax,ecx
		mov	ds:_X86_cpu,3
		jz	endProc
		
		push	ecx
		popfd		

.486
chk486:		mov	ds:_X86_cpu,4
		mov	eax,ecx
		xor	eax,200000h
		push	eax
		popfd
		pushfd
		pop	eax
		xor	eax,ecx
		je	endProc
		
		mov	ds:_X86_cpuidFlag,1
		push	ebx
		push	esi
		push	edi
		mov	eax,0
		MCPUID
		mov	dword ptr ds:_X86_vendor,ebx
		mov	dword ptr ds:_X86_vendor[+4],edx
		mov	dword ptr ds:_X86_vendor[+8],ecx
		
		cmp	eax,1
		jl	endProc1
		mov	eax,1
		MCPUID
		mov	ds:_X86_signature,eax
		mov	ds:_X86_features1,ebx
		mov	ds:_X86_features2,ecx
		mov	ds:_X86_features3,edx
		shr	eax,8
		and	eax,0fh
		mov	ds:_X86_cpu, al

endProc1:	pop	edi
		pop	esi
		pop	ebx

endProc:	ret
_X86_get_CPU 	ENDP

.387
_X86_get_FPU	PROC
		fninit
		mov	DS:fpu_status,5a5ah
		fnstsw	DS:fpu_status
		mov	ax,DS:fpu_status
		cmp	al,0
		mov	DS:_X86_fpu,0
		jne	endFPUProc

chkCW:		fnstcw 	DS:fpu_status
		mov	ax,DS:fpu_status
		and	ax,103fh
		cmp	ax,03fh
		mov	DS:_X86_fpu,0
		jne	endFPUProc
		mov	DS:_X86_fpu,1
		
chkInf:		cmp	DS:_X86_cpu,3
		jle	endFPUProc
		fld1
		fldz
		fdiv
		fld	st
		fchs
		fcompp
		fstsw	DS:fpu_status
		mov	DS:_X86_fpu,2
		sahf
		jz	endFPUProc
		mov	DS:_X86_fpu,3

endFPUProc:	ret
_X86_get_FPU	ENDP

_TEXT           ENDS

END
