/* Project:      HARTIK 3.0                                      */
/* Description:  Hard Real TIme Kernel for 386 & higher machines */
/* Author:       Gerardo Lamastra                        	 	 */
/* Date:         9/5/96                                          */
/* Revision:     2.0						 					 */

/* Module: VMCPU32.S						 					 */
/* Virtual Machine level for 386 & upper compatible processor 	 */

.title	"VmCPU32.S"

/*
 * The following code has been extracted by Intel AP-485
 * Application Note: Intel Processor Identification with CPUID instruction
 */

.data

.globl	_X86_cpu
.globl	_X86_cpu
.globl	_X86_fpu
.globl	_X86_v86Flag
.globl	_X86_cpuidFlag
.globl	_X86_vendor
.globl	_X86_signature
.globl	_X86_features1
.globl	_X86_features2
.globl	_X86_features3

_X86_cpu:	.byte	0
_X86_fpu:	.byte	0
_X86_v86Flag:	.byte	0
_X86_cpuidFlag:	.byte	0
_X86_vendor:	.space	13,0
_X86_signature:	.int	0
_X86_features1:	.int	0
_X86_features2:	.int	0
_X86_features3:	.int	0
fpu_status:	.word	0

.text

.globl _X86_get_CPU
.globl _X86_get_FPU

_X86_get_CPU:	pushfl
		popl	%eax
		movl	%eax,%ecx
		xorl	$0x40000,%eax
		pushl	%eax
		popfl
		pushfl
		popl	%eax
		xorl	%ecx,%eax
		movb	$3,_X86_cpu
		jz	endProc
		
		pushl	%ecx
		popfl	

chk486:		movl	$4,_X86_cpu
		movl	%ecx,%eax
		xorl	$0x200000,%eax
		pushl	%eax
		popfl
		pushfl
		popl	%eax
		xorl	%ecx,%eax
		je	endProc
		
		movl	$1,_X86_cpuidFlag
		pushl	%ebx
		pushl	%esi
		pushl	%edi
		movl	$0,%eax
		.byte 0x0F,0xA2
/*		cpuid */
		movl	%ebx,_X86_vendor
		movl	%edx,_X86_vendor+4
		movl	%ecx,_X86_vendor+8
		
		cmpl	$1,%eax
		jl	endProc1
		movl	$1,%eax
		.byte 0x0F,0xA2
/*		cpuid */
		movl	%eax,_X86_signature
		movl	%ebx,_X86_features1
		movl	%ecx,_X86_features2
		movl	%edx,_X86_features3
		shrl	$8,%eax
		andl	$0x0F,%eax
		movb	%al,_X86_cpu

endProc1:	popl	%edi
		popl	%esi
		popl	%ebx

endProc:	ret

_X86_get_FPU:	fninit
		movw	$0x5a5a,fpu_status
		fnstsw	fpu_status
		movw	fpu_status,%ax
		cmpb	$0,%al
		movb	$0,_X86_fpu
		jne	endFPUProc

chkCW:		fnstcw 	fpu_status
		movw	fpu_status,%ax
		andw	$0x103f,%ax
		cmpw	$0x03F,%ax
		movb	$0,_X86_fpu
		jne	endFPUProc
		movb	$1,_X86_fpu
		
chkInf:		cmpb	$3,_X86_cpu
		jle	endFPUProc
		fld1
		fldz
		fdiv
		fld	%st
		fchs
		fcompp
		fstsw	fpu_status
		movb	$2,_X86_fpu
		sahf
		jz	endFPUProc
		movb	$3,_X86_fpu
endFPUProc:	ret
