/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:      Gerardo Lamastra                                */
/* Date:        9/5/96                                          */
/* Revision:    Beta 2.0                                        */

/* File: VMInit.C                                */
/* Virtual machine layer/32 bit 386 architecture */
/* Watcom C Compiler version			 */

/* VM Startup code */

#include <string.h>
#include <stdlib.h>
#include <xsys.h>
#include <mem.h>
#include <cons.h>

#include "tss-ctx.h"
#include "vm.h"
#include "kern.h"

/* Timer 0 usec base tick */
DWORD VM_tick;
/* Timer 0 loaded time constant (= VM_tick * 1.197) */
WORD  VM_time_const;
/* Architecture definition */
VM_ARCH VM_arch;

/* These are declared in VMCx32b.C */
extern TSS  TSS_table[];
extern WORD TSS_control[];
extern BYTE VM_FPU_stdctx[];

/* The following stuff is in VMCxA.Asm/S	*/

/* Timer 0 counter */
#ifndef __LINUX__
extern DWORD VM_clock;
#else
extern DWORD _VM_clock;
extern DWORD VM_clock __attribute__((weak,alias("_VM_clock")));
#endif
/* Assembly external routines! 		*/
/* Setup the TR register of the 80386, to initialize context switch */

#ifndef __LINUX__
extern void init_TR(WORD v);
#else
extern void _init_TR(WORD v);
extern void init_TR(WORD v) __attribute__((weak,alias("_init_TR")));
#endif

/* VM hardware interrupt hooks	*/
#ifndef __LINUX__
extern void __cdecl VM_timer(void);
extern void __cdecl h01(void);
extern void __cdecl h02(void);
extern void __cdecl h03(void);
extern void __cdecl h04(void);
extern void __cdecl h05(void);
extern void __cdecl h06(void);
extern void __cdecl h07(void);
extern void __cdecl h08(void);
extern void __cdecl h09(void);
extern void __cdecl h10(void);
extern void __cdecl h11(void);
extern void __cdecl h12(void);
extern void __cdecl h13(void);
extern void __cdecl h13_bis(void);
extern void __cdecl h14(void);
extern void __cdecl h15(void);
#else
extern void __cdecl _VM_timer(void);
extern void __cdecl _h01(void);
extern void __cdecl _h02(void);
extern void __cdecl _h03(void);
extern void __cdecl _h04(void);
extern void __cdecl _h05(void);
extern void __cdecl _h06(void);
extern void __cdecl _h07(void);
extern void __cdecl _h08(void);
extern void __cdecl _h09(void);
extern void __cdecl _h10(void);
extern void __cdecl _h11(void);
extern void __cdecl _h12(void);
extern void __cdecl _h13(void);
extern void __cdecl _h13_bis(void);
extern void __cdecl _h14(void);
extern void __cdecl _h15(void);

extern void __cdecl VM_timer(void) __attribute__((weak,alias("_VM_timer")));
extern void __cdecl h01(void) __attribute__((weak,alias("_h01")));
extern void __cdecl h02(void) __attribute__((weak,alias("_h02")));
extern void __cdecl h03(void) __attribute__((weak,alias("_h03")));
extern void __cdecl h04(void) __attribute__((weak,alias("_h04")));
extern void __cdecl h05(void) __attribute__((weak,alias("_h05")));
extern void __cdecl h06(void) __attribute__((weak,alias("_h06")));
extern void __cdecl h07(void) __attribute__((weak,alias("_h07")));
extern void __cdecl h08(void) __attribute__((weak,alias("_h08")));
extern void __cdecl h09(void) __attribute__((weak,alias("_h09")));
extern void __cdecl h10(void) __attribute__((weak,alias("_h10")));
extern void __cdecl h11(void) __attribute__((weak,alias("_h11")));
extern void __cdecl h12(void) __attribute__((weak,alias("_h12")));
extern void __cdecl h13(void) __attribute__((weak,alias("_h13")));
extern void __cdecl h13_bis(void) __attribute__((weak,alias("_h13_bis")));
extern void __cdecl h14(void) __attribute__((weak,alias("_h14")));
extern void __cdecl h15(void) __attribute__((weak,alias("_h15")));
#endif

/* VM hardware exception hooks	*/
/* In VMCtx1.Asm/s				*/
#ifndef __LINUX__
extern void __cdecl exc0(void);
extern void __cdecl exc1(void);
extern void __cdecl exc2(void);
extern void __cdecl exc3(void);
extern void __cdecl exc4(void);
extern void __cdecl exc5(void);
extern void __cdecl exc6(void);
extern void __cdecl exc7(void);
extern void __cdecl exc8(void);
extern void __cdecl exc9(void);
extern void __cdecl exc10(void);
extern void __cdecl exc11(void);
extern void __cdecl exc12(void);
extern void __cdecl exc13(void);
extern void __cdecl exc14(void);
extern void __cdecl exc15(void);
extern void __cdecl exc16(void);
#else
extern void __cdecl _exc0(void);
extern void __cdecl _exc1(void);
extern void __cdecl _exc2(void);
extern void __cdecl _exc3(void);
extern void __cdecl _exc4(void);
extern void __cdecl _exc5(void);
extern void __cdecl _exc6(void);
extern void __cdecl _exc7(void);
extern void __cdecl _exc8(void);
extern void __cdecl _exc9(void);
extern void __cdecl _exc10(void);
extern void __cdecl _exc11(void);
extern void __cdecl _exc12(void);
extern void __cdecl _exc13(void);
extern void __cdecl _exc14(void);
extern void __cdecl _exc15(void);
extern void __cdecl _exc16(void);

extern void __cdecl exc0(void)  __attribute__((weak,alias("_exc0")));
extern void __cdecl exc1(void) __attribute__((weak,alias("_exc1")));
extern void __cdecl exc2(void) __attribute__((weak,alias("_exc2")));
extern void __cdecl exc3(void) __attribute__((weak,alias("_exc3")));
extern void __cdecl exc4(void) __attribute__((weak,alias("_exc4")));
extern void __cdecl exc5(void) __attribute__((weak,alias("_exc5")));
extern void __cdecl exc6(void) __attribute__((weak,alias("_exc6")));
extern void __cdecl exc7(void) __attribute__((weak,alias("_exc7")));
extern void __cdecl exc8(void) __attribute__((weak,alias("_exc8")));
extern void __cdecl exc9(void) __attribute__((weak,alias("_exc9")));
extern void __cdecl exc10(void) __attribute__((weak,alias("_exc10")));
extern void __cdecl exc11(void) __attribute__((weak,alias("_exc11")));
extern void __cdecl exc12(void) __attribute__((weak,alias("_exc12")));
extern void __cdecl exc13(void) __attribute__((weak,alias("_exc13")));
extern void __cdecl exc14(void) __attribute__((weak,alias("_exc14")));
extern void __cdecl exc15(void) __attribute__((weak,alias("_exc15")));
extern void __cdecl exc16(void) __attribute__((weak,alias("_exc16")));
#endif

/* From VMStuff.C */
void VM_PIC_init(void);
void VM_PIC_end(void);

void __cdecl VM_exc_hook(int i)
{
    static char *exc_mess[] = {
	"#Division by 0",
	"#NMI detected",
	"#Debug fault",
	"#Breakpoint trap",
	"#Overflow detected on INTO",
	"#BOUND limit exceeded",
	"*Unvalid opcode",
	"1FPU context switch", /* Handled in the VMCtx.Asm/S File */
	"*Double defect",
	"#INTEL reserved",
	"*Unvalid TSS",
	"*Segment not present",
	"*Stack exception",
	"*General protection fault",
	"#Page fault",
	"#INTEL reserved",
	"2Coprocessor error"
    };

    static exc_code[] = {
	DIV_BY_0,DEBUG_EXC,BREAKPOINT_EXC,VM_FAULT,
	VM_FAULT,VM_FAULT,VM_FAULT,0,
	VM_FAULT,VM_FAULT,VM_FAULT,VM_FAULT,
	VM_FAULT,VM_FAULT,VM_FAULT,MATH_EXC
    };

    char code = *exc_mess[i];
    #ifdef __VM_DEBUG__
	extern long int ndp_called,ndp_switched;
	extern wu_called;
	extern ai_called;
	extern DWORD *smain;
    #endif

    /* Math error! FPU has to be acknowledgded */
    if (code == '2') VM_out(0x0F0,0);
    
    #ifdef __VM_DEBUG__
	VM_printf("Exception %d occurred\n",i);
	VM_printf("%s\n",&exc_mess[i][1]);
	if (code == '*') {
	    /* Dump additional info */
	    VM_printf("DS:%nx CS:%nx\n",get_DS(),get_CS());
	    VM_printf("WU : %d AI : %d\n",wu_called,ai_called);
	    VM_printf("Actual stack : %x\n",get_SP());
	    VM_printf("Main stack : %p\n",smain);
	    dump_TSS(get_TR());
	}
    #endif
    VM_abort(exc_code[i]);
}

void VM_init(TIME t)
{
    register i;
    DWORD b,s;
    BYTE *base;
    BYTE v;
    /* In VMCPU16.Asm! Used to identify CPU & FPU 
	 * Sorry for this dirty code, but Linux needs to alias
	 * all the assembler names, because it does not use the _* convention
	 */
#ifndef __LINUX__
    extern BYTE X86_cpu;
    extern BYTE X86_fpu;
    extern BYTE X86_cpuidFlag;
    extern BYTE X86_vendor;
    extern DWORD X86_signature;
    extern DWORD X86_features1;
    extern DWORD X86_features2;
    extern DWORD X86_features3;
    void __cdecl X86_get_CPU();
    void __cdecl X86_get_FPU();
    X86_get_CPU();
    X86_get_FPU();
    VM_arch.x86.arch = __VM_ARCH__;
    VM_arch.x86.cpu = X86_cpu;
    VM_arch.x86.fpu = X86_fpu;
    VM_arch.x86.vendor = &X86_vendor;
    /* TODO! Need to map featuresXXX & Signature onto VM_arch!  */
    /* TODO! Need to check for CPU bugs!!			*/
    #ifdef __VM_DEBUG__
	VM_printf("VM Architecture: %s\n",__VM_ARCH__);
	VM_printf("CPU : %u\nFPU : %u\n",X86_cpu,X86_fpu);
	VM_printf("Signature : 0x%lx\nVendor: %s\n",X86_signature,&X86_vendor);
	VM_printf("Features #1: 0x%lx\n",X86_features1);
	VM_printf("Features #2: 0x%lx\n",X86_features2);
	VM_printf("Features #3: 0x%lx\n",X86_features3);
    #endif /* __VM_DEBUG__ */
#else
    extern BYTE _X86_cpu;
    extern BYTE _X86_fpu;
/*    extern BYTE _X86_cpuidFlag;*/
    extern BYTE _X86_vendor;
#ifdef __VM_DEBUG__
    extern DWORD _X86_signature;
    extern DWORD _X86_features1;
    extern DWORD _X86_features2;
    extern DWORD _X86_features3;
#endif
    void __cdecl _X86_get_CPU();
    void __cdecl _X86_get_FPU();
    _X86_get_CPU();
    _X86_get_FPU();
    VM_arch.x86.arch = __VM_ARCH__;
    VM_arch.x86.cpu = _X86_cpu;
    VM_arch.x86.fpu = _X86_fpu;
    VM_arch.x86.vendor = &_X86_vendor;
    /* TODO! Need to map featuresXXX & Signature onto VM_arch!  */
    /* TODO! Need to check for CPU bugs!!			*/
    #ifdef __VM_DEBUG__
	VM_printf("VM Architecture: %s\n",__VM_ARCH__);
	VM_printf("CPU : %u\nFPU : %u\n",_X86_cpu,_X86_fpu);
	VM_printf("Signature : 0x%lx\nVendor: %s\n",_X86_signature,&_X86_vendor);
	VM_printf("Features #1: 0x%lx\n",_X86_features1);
	VM_printf("Features #2: 0x%lx\n",_X86_features2);
	VM_printf("Features #3: 0x%lx\n",_X86_features3);
	#endif /* __VM_DEBUG__ */
#endif /* __LINUX__ */
    /* Translate the tick value in usec into a suitable time constant   */
    /* for 8254 timer chip; the chip is driven with a 1.19718 MHz       */
    /* frequency; then the effective frequency is given by the base     */
    /* frequency divided for the time constant; the tick is the inverse */
    /* of this effective frequency (in usec!)                           */
    /* Time-Constant = f_base (MHz) * tick (usec)                       */
    /* If T-C == 0 -> T-C = 65536 (Max available)                       */
    VM_tick = t;
    t = t * 1197;
    t = t / 1000;
    /* Only for security! This should cause timer overrun */
    /* While 0 would set maximum period on timer          */
    if (t == 0) t = 1;
    VM_time_const = (WORD)(t & 0xFFFF);
    
    /* Insert the Exceptions handler into IDT */
    IDT_place(0x00,exc0);
    IDT_place(0x01,exc1);
    IDT_place(0x02,exc2);
    IDT_place(0x03,exc3);
    IDT_place(0x04,exc4);
    IDT_place(0x05,exc5);
    IDT_place(0x06,exc6);
    IDT_place(0x07,exc7);
    IDT_place(0x08,exc8);
    IDT_place(0x09,exc9);
    IDT_place(0x0A,exc10);
    IDT_place(0x0B,exc11);
    IDT_place(0x0C,exc12);
    IDT_place(0x0D,exc13);
    IDT_place(0x0E,exc14);
    IDT_place(0x0F,exc15);
    IDT_place(0x10,exc16);
    /* Insert HW timer handler into IDT */
    IDT_place(0x40,VM_timer);
    IDT_place(0x41,h01);
    IDT_place(0x42,h02);
    IDT_place(0x43,h03);
    IDT_place(0x44,h04);
    IDT_place(0x45,h05);
    IDT_place(0x46,h06);
    IDT_place(0x47,h07);
    IDT_place(0x70,h08);
    IDT_place(0x71,h09);
    IDT_place(0x72,h10);
    IDT_place(0x73,h11);
    IDT_place(0x74,h12);
    
    /* If FPU is on-chip IRQ #13 is free to use */    
    /* Else IRQ #13 vectors the coprocessor errors */
    if (VM_FPU_check()) VM_arch.x86.capabilities |= VM_X86_INTERNAL_FPU;
    #ifdef __VM_DEBUG__
	cprintf("Check FPU : %s\n",VM_arch.x86.capabilities & VM_X86_INTERNAL_FPU ? "Internal" : "External");
    #endif
    if (VM_arch.x86.capabilities & VM_X86_INTERNAL_FPU) {
	/* Install the generic handler */
	IDT_place(0x75,h13);
    } else {
	/* Install the external FPU error handler */
	IDT_place(0x75,h13_bis);
	VM_irq_unmask(13);
    }
    IDT_place(0x76,h14);
    IDT_place(0x77,h15);
    /* Get info about extended memory! We suppose that X has loaded */
    /* there the application; if you switch to DOS memory, then you */
    /* have to change the stuff in order it works; check X_...  for */
    /* details.                                                     */
    X_meminfo(&b,&s,NULL,NULL);
    base = linear2appl(b);
    #ifdef __MEM_DEBUG__
	VM_printf("PM Free Mem Base         : %x\n",b);
	VM_printf("PM null addr (0L)        : %x\n",appl2linear((void *)0L));
	VM_printf("PM Free Mem Base (Cnvrtd): %p\n",base);
    #endif
    VM_mem_init(base,s);
    #ifdef __MEM_DEBUG__
	VM_mem_dump();
    #endif

    /* Init TSS table & put the corrispondent selectors into GDT */
    TSS_control[TSSMain] |= TSS_USED;
    for (i = 0; i < TSSMax; i++) {
	b = appl2linear(&TSS_table[i]);
	GDT_place(TSSindex2sel(i),b,sizeof(TSS),FREE_TSS386,GRAN_16);
    }
    /* Set the TR initial value */
    init_TR(TSSindex2sel(TSSMain));
    /* Init coprocessor & assign it to main() */
    VM_FPU_reset();
    VM_FPU_save();
    memcpy(VM_FPU_stdctx,VM_FPU_savearea,FPU_CONTEXT_SIZE);
    VM_FPU_init();
    /* Set up timer chip */
    /* Mode: Binary/Mode 2/16 bit Time_const/Counter 0 */
    VM_out(0x43,0x34);
    /* Load Time_const with 2 access to CTR */
    v = (BYTE)(VM_time_const);
    VM_out(0x40,v);
    v = (BYTE)(VM_time_const >> 8);
    VM_out(0x40,v);
    /* Init PIC controllers & unmask timer */
    VM_PIC_init();
    VM_out(0x21,0xFE);
}

void VM_end(void)
{
    VM_out(0x21,0xFF);
    VM_out(0xA1,0xFF);
    /* Back to DOS settings */
    VM_PIC_end();
    /* Reset the timer chip according DOS specification */
    /* Mode: Binary/Mode 3/16 bit Time_const/Counter 0 */
    VM_out(0x43,0x36);
    /* Time_const = 65536; write 0 in CTR */
    VM_out(0x40,0);
    VM_out(0x40,0);
}
