/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:      Gerardo Lamastra                                */
/* Date:        12/7/1998                                       */
/* Revision:    Beta 2.0                                        */

/* File: VMStuf32.C							*/
/* VM_* 32 bit utility functions: {VM_PIC_[init,end],VM_P5_timer_read}	*/

#include <stdlib.h>
#include <string.h>
#include <mem.h>

#include "vm.h"
#include "cons.h"

#define ICW1_M 	0x020 /* Master PIC (8259) register settings */
#define ICW2_M  0x021
#define ICW3_M  0x021
#define ICW4_M  0x021
#define OCW1_M  0x021
#define OCW2_M  0x020
#define OCW3_M  0x020

#define ICW1_S  0x0A0 /* Slave PIC register setting */
#define ICW2_S  0x0A1
#define ICW3_S  0x0A1
#define ICW4_S  0x0A1
#define OCW1_S  0x0A1
#define OCW2_S  0x0A0
#define OCW3_S  0x0A0

#define PIC1_BASE 0x040 /* Interrupt base for each PIC in HARTIK 3.0 */
#define PIC2_BASE 0x070 
#define EOI       0x020 /* End Of Interrupt code for PIC! */

void VM_PIC_init(void)
{
    VM_out(ICW1_M,0x11);
    VM_out(ICW2_M,PIC1_BASE);
    VM_out(ICW3_M,0x04);
    VM_out(ICW4_M,0x01);
    VM_out(OCW1_M,0xFF);

    VM_out(ICW1_S,0x11);
    VM_out(ICW2_S,PIC2_BASE);
    VM_out(ICW3_S,0x02);
    VM_out(ICW4_S,0x01);
    VM_out(OCW1_S,0xFF);
}

void VM_PIC_end(void)
{
    VM_out(ICW1_M,0x11);
    VM_out(ICW2_M,0x08);
    VM_out(ICW3_M,0x04);
    VM_out(ICW4_M,0x01);
    VM_out(OCW1_M,0xFF);

    VM_out(ICW1_S,0x11);
    VM_out(ICW2_S,0x70);
    VM_out(ICW3_S,0x02);
    VM_out(ICW4_S,0x01);
    VM_out(OCW1_S,0xFF);
}
