/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	2/6/98 						*/
/* Revision:	2.0						*/

/* File: StrBase.C */
/* Standard library for X applications */

/* Basic string conversion stuff */

#include <stdlib.h>
#include <string.h>

char _toupper(char c)
{
    if (c >= 'a' && c <= 'z') return(c-'a'+'A');
    else return(c);
}

char _tolower(char c)
{
    if (c >= 'A' && c <= 'A') return(c-'A'+'a');
    else return(c);
}

int _tonumber(char c)
{
    if (c >= '0' && c <= '9') return(c - '0');
    else if (c >= 'A' && c <= 'F') return(c - 'A' + 10);
    else if (c >= 'a' && c <= 'f') return(c - 'a' + 10);
    else return(c);
}

char _todigit(int c)
{
    if (c >= 0 && c <= 9) return(c+'0');
    else if (c >= 10 && c <= 15) return(c + 'A' - 10);
    else return(c);    
}

int _isnumber(char c,int base)
{
    static char *digits = "0123456789ABCDEF";
    if ((c >= '0' && c <= digits[base-1]))
       return(1);
    else return(0);
}

int _isspace(char c)
{
    if ((c >= 0x09 && c <= 0x0d) || (c == 0x20)) return(1);
    return(0);
}

int _isspecial(double d,char *bufp)
{
    /* IEEE standard number rapresentation */
    register struct IEEEdp {
	unsigned manl:32;
	unsigned manh:20;
	unsigned exp:11;
	unsigned sign:1;
    } *ip = (struct IEEEdp *)&d;

    if (ip->exp != 0x7ff) return(0);
    if (ip->manh || ip->manl) {
	if (bufp != NULL) strcpy(bufp,"NaN");
	return(1);
    }
    else if (ip->sign) {
	if (bufp != NULL) strcpy(bufp,"+Inf");
	return(2);
    } else {
	if (bufp != NULL) strcpy(bufp,"-Inf");
	return(3);
    }
}

/* For Linux/ELF cross-compiling! Damned Math Library! */
int __isinf(double x)
{
	return (_isspecial(x,NULL) > 1);
}

int __isnan(double x)
{
	return (_isspecial(x,NULL) == 1);
}
