/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	2.0						*/

/* CVS $Id: string.c,v 1.3 1999/07/09 10:14:58 massy Exp $ */

/* File: String.C			*/
/* Standard library for X applications  */

/* String manipulation functions */

#include <string.h>

char *strcpy(char *dst,char *src)
{
    char *retval = dst;
    while (*src != 0) *dst++ = *src++;
    *dst = 0;
    return(retval);
}

char *strncpy(char *dst,char *src,int n)
{
    char *retval = dst;
    while (*src != 0 && n-- > 0) *dst++ = *src++;
    *dst = 0;
    return(retval);
}

/*
  bug:
  comparing PIPPO and PIPPO25 -> result 0 !!! 
int strcmp(char *s1,char *s2)
{
    int result = 0;
    while (*s1 != 0 && result == 0)
	result = (*s1++ - *s2++);
    return(result);
}
*/

/* from: glibc 2.1.1 */

#define reg_char char

/* Compare S1 and S2, returning less than, equal to or
   greater than zero if S1 is lexicographically less than,
   equal to or greater than S2.  */
int
strcmp (p1, p2)
     char *p1;
     char *p2;
{
  register const unsigned char *s1 = (const unsigned char *) p1;
  register const unsigned char *s2 = (const unsigned char *) p2;
  unsigned reg_char c1, c2;

  do
    {
      c1 = (unsigned char) *s1++;
      c2 = (unsigned char) *s2++;
      if (c1 == '\0')
	return c1 - c2;
    }
  while (c1 == c2);

  return c1 - c2;
}

int strncmp(char *s1,char *s2,int n)
{
    int result = 0;
    while (*s1 != 0 && result == 0 && n-- > 0) result = (*s1++ - *s2++);
    return(result);
}

char *strupr(char *s)
{
    char *base = s;
    while (*s != 0) {
	if (*s >= 'a' && *s <= 'z')
           *s = *s + 'A' -'a';
	s++;
    }
    return(base);
}

char *strlwr(char *s)
{
    char *base = s;
    while (*s != 0) {
	if (*s >= 'A' && *s <= 'Z')
	   *s = *s + 'a' -'A';
	s++;
    }
    return(base);
}

int strlen(char *s)
{
    register int result = 0;
    while (*s != 0) s++ , result++;
    return(result);
}

char *strcat(char *dst,char *src)
{
    char *base = dst;
    while (*dst != 0) dst++;    
    while (*src != 0) *dst++ = *src++;
    *dst = 0;
    return(base);
}

char *strscn(char *s,char *pattern)
{
    char *scan;
    while (*s != 0) {
    	scan = pattern;
    	while (*scan != 0) {
	    if (*s == *scan) return(s);
	    else scan++;
	}
	s++;
    }
    return(NULL);
}

char *strchr(char *s,int c)
{
    while (*s != 0) {
	if (*s == (char)(c)) return(s);
	else s++;
    }
    return(NULL);
}
