/* Project:     HARTIK 3.0                      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:  	Gerardo Lamastra               					*/
/* Date:    	9/5/96                     						*/
/* Revision:    Beta 1.0		                   				*/

/* File: lmemcomp.C */
/* Emulation of lmem* functions under 16 bit systems */

#include <stdlib.h>
#include <mem.h>

unsigned long appl2linear(void *p)
{
    LIN_ADDR a;
    a = FP_OFF(p) + (FP_SEG(p) << 4);
    return a;
}

void *linear2appl(DWORD a)
{
    void *p = MK_FP(((a & 0xFFFF0) >> 4),a & 0x000F);
    return p;
}

void lmemcpy(LIN_ADDR dest,LIN_ADDR src,unsigned n)
{
    memcpy(linear2appl(dest),linear2appl(src),n);
}

int lmemcmp(LIN_ADDR dest,LIN_ADDR src,unsigned n)
{
    return memcmp(linear2appl(dest),linear2appl(src),n);
}

void lmemset(LIN_ADDR dest,char v,unsigned n)
{
    memset(linear2appl(dest),v,n);
}

int lmemchr(LIN_ADDR dest,char v,unsigned n)
{
    return memchr(linear2appl(dest),v,n);
}

LIN_ADDR DOS_alloc(DWORD size)
{
    return VM_alloc(size);
}

void DOS_free(LIN_ADDR ap,DWORD size)
{
    void *p = linear2appl(ap);
    VM_free(p,size);
}
