/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	2.0/WC						*/

/* File: XConv.C			   		  */
/* System calls for X extender 			  	  */
/* The X <-> Phisical address conversion		  */

#include <xsys.h>
#include <mem.h>

/* Conversion between PM address space & phisical address space */
/* If we do not support paging we need to relocate the .ELF executable  */
/* using the segment register; however we also need to access all the   */
/* phisical memory; for example if we allocate some memory (phisical)   */
/* and we use a pointer to access that memory, the pointer will use     */
/* the current DS to address the specified offset; but the phisical     */
/* offset cannot be used because the base of DS is not zero as required */
/* to access phisical memory; the DS base is stored by X into the       */
/* exec_base field of _X_info! This is the key to traslate ELF address  */
/* into phisical address & viceversa					*/

DWORD appl2linear(void *p)
{
    unsigned long result;
    result = (DWORD)(p) + _X_info->exec_base;
    return(result);
}

void *linear2appl(DWORD a)
{
    void *p;
    if (a < _X_info->exec_base) p = NULL;
    else p = (void *)(a-_X_info->exec_base);
    return(p);
}

DWORD addr2linear(unsigned short seg,unsigned long offset)
{
    DWORD flatbase;
    flatbase = GDT_read(seg,NULL,NULL,NULL);
    return(flatbase + offset);
}
