/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	2.0						*/

/* File: XInfo.C		   			  */
/* System calls for X extender 			  	  */

/* Access the X_info stucture & other useful stuff */

#include <xsys.h>
#include <cons.h>
#include <mem.h>

/* The X_info structure cannot be unique due to incapacity of GNU C 	*/
/* to manage far pointers. So we have a copy of X_info cached locally	*/
/* in the COFF address space and the real X_info structure in the X	*/
/* address space. These functions performs caching of the real X_info	*/
/* in the local structure and updating of the real X_info with data	*/
/* from the local copy.							*/

void cache_X_info(void)
{
    fmemcpy(PM_APPLDATA_SEL,(DWORD)_X_info,X_INFO_SEL,0,sizeof(struct info));
}   

void update_X_info(void)
{
    fmemcpy(X_INFO_SEL,0,PM_APPLDATA_SEL,(DWORD)_X_info,sizeof(struct info));
}

/* Stuff information retrieving function */

WORD X_version(void)
{
    return(_X_info->ver);
}

void X_meminfo(DWORD *b1,DWORD *s1,DWORD *b2,DWORD *s2)
{
    if (b1 != NULL) *b1 = _X_info->extended_base;
    if (s1 != NULL) *s1 = _X_info->extended_size;
    if (b2 != NULL) *b2 = _X_info->dos_base;
    if (s2 != NULL) *s2 = _X_info->dos_size;
}

/* Alert if a wrong addressing is intercepted 	*/
/* Used only for debug purposes			*/

void check_addr(void *addr,char *caller)
{
    extern DWORD _stktop;
    if ((DWORD)(addr) < _stktop) {
	cprintf("CRISIS! Addr : %lx(%lx) Caller was %s\n",(DWORD)(addr),_stktop,caller);
    }
}

