/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	2.0						*/

/* File: XTest.C		*/
/* Library test program		*/

#include <math.h>
#include <cons.h>
#include <string.h>
#include <stdlib.h>
#include <mem.h>
#include <xdos.h>
#include <xsys.h>

#define WAIT()	for (w = 0; w < 0x5FFFFFF; w++)

/* This is just to try some stuff */

extern DWORD _stkbase;
DWORD w;

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*				IRQDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#define BLINK_CHAR	'*'
static blink = BLINK_CHAR;

#if 0

#ifdef __386__ /* Watcom C */
static unsigned volatile tick_num = 0;
void __interrupt __cdecl tick(void)
{    
    lmempokeb(0xB8000 + 158,blink);
    blink ^= BLINK_CHAR;
    tick_num++;
    outp(0x20,0x20);
}
#else /* Hopefully GNU-C */
extern unsigned volatile tick_num;
extern void tick(void);
/* Sorry, the interrupt stub needs to be defined in assembly! */
/* The file is gnu/tick.S */
#endif

void IrqDemo()
{
    lmempokeb(0xB8000 + 158,0);
    
    IDT_place(0x08,(void __cdecl *)(tick));
    outp(0x21,0xFE);
    while (tick_num < 100) printf_xy(0,0,WHITE,"Tick : %u",tick_num);
    outp(0x21,0xFF);
}

#else

void IrqDemo()
{}

#endif

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*			CONVDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

void ConvDemo(void)
{
    int x  = 0;
    int x1 = -12345;
    int x2 = -123456;
    int x3 = -1234567;
    double y1 = 1.27691234567,little = 1.23456e-100,big = 1.23456e+100;    
    float  fy1 = 2769.1234567,flittle = 1.23456e-10,fbig = 1.23456e+10;
    char try[90];
    char s1[20],s2[20];
    
    cputs(".|\t|..|\t|...|\t|....|\t|.....|\t|......|\t|.......|\t|........|\t|\n");
    cprintf("X(0): %d/%x/%u\n",x,x,x);
    cprintf("X1(-12345): %d/%x/%u\n",x1,x1,x1);
    cprintf("X2(-123456): %d/%x/%u\n",x2,x2,x2);
    cprintf("X3(-1234567): %d/%x/%u\n",x3,x3,x3);
    cprintf("Y1(1.27691234567): %g/%e/%f\n",y1,y1,y1);
    cprintf("Little(1.23456e-100): %g/%e/%f\n",little,little,little);
    cprintf("Big(1.23456e+100): %g/%e/%f\n",big,big,big);
    cprintf("Y1(2769.1234567): %g/%e/%f\n",fy1,fy1,fy1);
    cprintf("Little(1.23456e-10): %g/%e/%f\n",flittle,flittle,flittle);
    cprintf("Big(1.23456e+10): %g/%e/%f\n",fbig,fbig,fbig);

    strcpy(try,"-1234 0xCAFF 1234 0.123456 1e+100 1e-100 Pippero Pippo-Only5");
    cprintf("Should be %s\n",try);
    x = x1 = x2 = 0;
    y1 = little = big = 0;
    sscanf(try,"%i %x %u %f %g %e %s %5s",&x,&x1,&x2,&y1,&little,&big,s1,s2);
    cprintf("Gotta: %i 0x%x %u %f %g %e %s %s\n",x,x1,x2,y1,little,big,s1,s2);
}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*			MATHDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

void MathDemo(void)
{
    double d = 2.56;
    cprintf("Sqrt of %lg is %lg\n",d,sqrt(d));
    d = pow(2,0.5);
    cprintf("Sqrt(via pow()) of 2 is %lg\n",d);

}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*			STRSDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

char dst[40];
char dst2[40];

void StrDemo(void)
{
    char *src = "Just 15 chars should appear...";
    
    DWORD sl,dl,d_addr;
    memcpy(dst,src,15);
    cprintf("1) : %s %u\n",dst,strlen(dst));
    sl = appl2linear(src);
    dl = appl2linear(dst2);
    lmemcpy(dl,sl,14);
    cprintf("2) : %s\n",dst2);
    d_addr = (DWORD)(dst2);
    cprintf("Address of dst2 is %p [%x]\n",dst2,d_addr);
    cprintf("Linear Address of dst2 is %x [%x]\n",dl,d_addr + _X_info->exec_base);
}


/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*			BIOSDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

void BIOSDemo(void)
{
    X_REGS16 ir,or;
    X_SREGS16 sr;
    register i;
    /* Set video mode */
    ir.h.ah = 0;
    ir.h.al = 0x12;
    X_callBIOS(0x10,&ir,&or,&sr);
    /* Put some pixels */
    
    for (i = 0; i < 200; i++) {
	ir.h.ah = 0x0C;
	ir.h.al = i % 16;
	ir.x.bx = 0;
	ir.x.dx = i+40;
	ir.x.cx = i+100;
	X_callBIOS(0x10,&ir,&or,&sr);
    }
    WAIT();
    /* Set video mode */
    ir.h.ah = 0;
    ir.h.al = 0x03;    
    X_callBIOS(0x10,&ir,&or,&sr);
}

void BIOSBufDemo(void)
{
    X_REGS16 ir,or;
    X_SREGS16 sr;
    register i;
    LIN_ADDR DOS_buf;
    struct {
	BYTE r,g,b;
    } pal[16];
        
    DOS_buf = DOS_alloc(3*16);
    lmemset(DOS_buf,5,3*16);

    /* Read palette table */
    ir.x.ax = 0x1017;
    ir.x.bx = 0;
    ir.x.cx = 16;
    ir.x.dx = DOS_OFF(DOS_buf);
    sr.es = DOS_SEG(DOS_buf);
    cprintf("DOS_buf address : %lx\n",DOS_buf);
    X_callBIOS(0x10,&ir,&or,&sr);
    lmemcpy(appl2linear(pal),DOS_buf,3*16);

    /* Set video mode */
    ir.h.ah = 0;
    ir.h.al = 0x03;    
    X_callBIOS(0x10,&ir,&or,&sr);

    for (i = 0; i < 16; i++) cprintf("Palette [%d] = [%u %u %u]\n",i,pal[i].r,pal[i].g,pal[i].b);
    DOS_free(DOS_buf,3*16);
}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*				DOSDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#define DISK_SIZE	1000

void DiskDemo(int argc,char *argv[])
{
    DOS_FILE *f;
    int v,c = 0;
    static char str[DISK_SIZE];

    if (argc < 3) {
	cprintf("Error! Give a valid file-name\n");
	exit(-1);
    }
    cprintf("Using file %s\n",argv[2]);
    if ((f = DOS_fopen(argv[2],"r")) == NULL) {
	cprintf("Error! Unvalid Open!!\n");
	cprintf("DOS Error : %u\n",DOS_error());
	exit(1);
    }
    cprintf("H1  : %d\nBegin to read\n",f->handle);
    do {
	memset(str,0,DISK_SIZE);
	v = DOS_fread(str,1,DISK_SIZE,f);
	c++;
	if (v != 0) cputs(str);
    } while (v == DISK_SIZE);

    cprintf("V : %d C : %d\n",v,c);
    cprintf("\nEnd\n");
    
    DOS_fclose(f);
}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*				DOSDEMO2				   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#define XTEST_DOS "xtest.t1"

void DiskDemo2(void)
{
    DOS_FILE *f;
    int i,v,c = 0;
    static char *str = "Let us try again...\n";
    static char readbuf[DISK_SIZE];

    if ((f = DOS_fopen(XTEST_DOS,"w")) == NULL) {
	cprintf("Error! Unvalid Open on writing for %s!!\n",XTEST_DOS);
	cprintf("DOS Error : %u\n",DOS_error());
	exit(1);
    }
    cprintf("H1  : %d\nBegin to writing...\n",f->handle);
    cprintf("Message : %s (Len: %u)\n",str,strlen(str));
    for (i = 0; i < 10; i++) {
	v = DOS_fwrite(str,1,strlen(str),f);
	cprintf("V : %d\n",v);
    }
    cprintf("\nEnd\n"); 
    DOS_fclose(f);

    if ((f = DOS_fopen(XTEST_DOS,"r")) == NULL) {
	cprintf("Error! Unvalid Open on reading for %s!!\n",XTEST_DOS);
	cprintf("DOS Error : %u\n",DOS_error());
	exit(1);
    }
    cprintf("H1  : %d\nBegin to read\n",f->handle);
    do {
	memset(readbuf,0,DISK_SIZE);
	v = DOS_fread(readbuf,1,DISK_SIZE,f);
	c++;
	if (v != 0) cputs(readbuf);
    } while (v == DISK_SIZE);
    
    cprintf("\nEnd\n"); 
    DOS_fclose(f);
}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
/*				GDTDEMO					   */
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

void GDTDemo(void)
{
    WORD ww = '$' | (RED << 8);
    cprintf("GDT Base is %x\n",_X_info->GDT_base);
    /* Alias for video memory set at 0x300 */
    cprintf("Setting an alias for the videoram\n",_X_info->GDT_base);
    GDT_place(0x300,0xB8000,0xFFFF,DATA_ACCESS,GRAN_16);
    cprintf("Base read is : %x\n",GDT_read(0x300,NULL,NULL,NULL));
    cprintf("A $ should appear...\n");
    fmemcpy(0x300,158,PM_APPLDATA_SEL,(DWORD)(&ww),2);
}

#define MAX_DEMOS (sizeof(demo_name)/sizeof(char *))

static char *demo_name[] = {
    "1BIOS ",
    "2BIOS ",
    "1Disk ",
    "2Disk ",
    "Math  ",
    "Conv  ",
    "GDT   ",
    "Irq   ",
    "String"
};

static char *demo_desc[] = {
    "Graphics switch/BIOS Demo\n",
    "Graphics+Real Mode Buffer/BIOS Demo\n",
    "Disk/BIOS read-only Demo\n",
    "Disk/BIOS r/w Demo\n",
    "Math Demo\n",
    "Conversion(sprintf) Demo\n",
    "GDT Management Demo\n",
    "Irq setup Demo\n",
    "String Management Demo\n"
};

main(int argc,char *argv[])
{
    int demo_id;
    cprintf("Hello world from the X extender\nVersion : %x\n",X_version());
    if (argc == 1) {
	cprintf("Demo available: %u\n",MAX_DEMOS);
	for (demo_id = 0; demo_id < MAX_DEMOS; demo_id++) {
	    cprintf("%s - %s",demo_name[demo_id],demo_desc[demo_id]);
	}
    } else {
	for (demo_id = 0; demo_id < MAX_DEMOS; demo_id++) {
	    if (strncmp(argv[1],demo_name[demo_id],3) == 0) break;
	}
    }
    switch (demo_id) {
	case 0 : BIOSDemo();          break;
	case 1 : BIOSBufDemo();       break;
	case 2 : DiskDemo(argc,argv); break;
	case 3 : DiskDemo2();         break;
	case 4 : MathDemo();          break;
	case 5 : ConvDemo();          break;
	case 6 : GDTDemo();           break;
	case 7 : IrqDemo();           break;
	case 8 : StrDemo();           break;
	default : cprintf("No demo selected\n"); demo_id = -1; break;
    }
    if (demo_id != -1) cprintf("Run demo %s\n",demo_name[demo_id]);
}
