# Standard library for X/COFF applications
# Makefile for GNU MAKE & GCC 2.8.0

# A Bulk Makefile Example!!!

CC 	 = gcc
AS	 = gcc
HARTIK   = ../..
INCL 	 = -I$(HARTIK)/h/x86 -I$(HARTIK)/h -I.
LIB_PATH = $(HARTIK)/lib

LINK_OPT = -oformat coff-go32 -s -nostartfiles -nostdlib -L$(LIB_PATH)
LINK_STARTUP = x0.o k_standa.o
LINK_LIB = -lhlib.a -lm 

C_OPT =  $(INCL) -O -finline-functions -fno-builtin -D__GNU__
A_OPT =  $(INCL) -D__GNU__

OBJS = # Your objs go here!!!

.PHONY : clean allclean depend info

info :
	@type ..\..\info.txt

#
# WARNING: do not mix GNU path & DOS path!!
#

all :

install : 

clean :
	-del *.o
	-del *.err
	-del makefile

allclean : 
	del ..\..\lib

#
# Here is an example on how to substitute in a more complex fashion
#
# $(patsubst %.o,gnu/%.c,$(GNU_C_OBJS)) s
#

depend :
	$(CC) $(C_OPT) -M $(OBJS:.o=.c) > deps

#
# A link example
#	
	
myappp : myapp.o libmylib.a
	ld $(LINK_STARTUP) $(LINK_LIB) -o myapp

myfile.o : myfile.S
	$(AS) $(A_OPT) -c $< -o $@

#
# A library example
#

%.o : %.c
	redir2 -e $(*F).err $(CC) $(C_OPT) -c $<

include deps
	
libmylib.a : $(OBJS)
	ar rs libmylib.a $(OBJS)

